(oglwin '.gl)
(pack  .gl) 
(define hello (make-vector 10 ()))

(define  font (.gl 'loadbitmapfont))

(define  (dlist-hello x y)
   (let* ((dlist  (.gl 'newlist)))
      (.gl 'eval :newlist dlist 'compile
	:clear 'colorbuffer 
	:rasterpos x y )
      (.gl 'printstring font "Hello World")
      (.gl 'eval :endlist) 
    dlist
))

(define (create-hello)
   (do ((i 0 (+ i 1)))
       ((= i 10))
       (vector-set! hello i (dlist-hello -1.0 (* 0.2 (- i 5))))
   )
)

(create-hello)

(do ((i 0 (+ i 1)))
    ((= i 101))
    (.gl 'main :call (vector-ref hello (modulo i 10)))
    (update)
    (after 100)
)


