;;;;  Caution!st
;;;  Never use  define for tk-variables
;;; for example 
;;;  (define img ())
;;; then img is only used in stk , and can't get tk-function  bind!!!
;;;;;
;;;(load "initogl") 
(define tk_library "/usr/local/lib/tk8.4")
;;(define img ())
(define ( createcheckerimg )
    (image 'create 'photo 'tmp :width 2 :height 2)
    (image 'create 'photo 'img :width 64 :height 64)
    ;(tmp 'put '( (#xffffff #xff0000) (#x000000 #xffffff)) ) 
    (tmp 'put '( ("#ffffff" "#ff0000") ("#000000" "#ffffff")) ) 
    (img 'copy 'tmp :from 0 0 2 2 :zoom 4 4 :to 0 0 64 64)
    (set! tmp ())
)
#|
(define (redisplay)
    (.gl 'main :matrixmode 'projection 
	    :loadidentity 
	    :perspective 30 1 0.1 10 
	    :matrixmode 'modelview 
	    :loadidentity 
	    :lookat -3 2 3  0 0 0  0 1 0 
	    :clear 'depthbuffer 'colorbuffer
	    :rotate yrot 1 1 0 :call dlist)
    (set! yrot (+  yrot 5))
    (after 50 '(redisplay))
    (update)   ;;;; added by sato
)
|#

(define redisplay
  (let ((id #f))
    (lambda()
       (.gl 'main :matrixmode 'projection
            :loadidentity
            :perspective 30 1 0.1 10
            :matrixmode 'modelview
            :loadidentity
            :lookat -3 2 3  0 0 0  0 1 0
            :clear 'depthbuffer 'colorbuffer
            :rotate yrot 1 1 0 :call dlist)
        (set! yrot (+  yrot 5))
       ;;; (if id (after 'cancel id))   Not need
        (set! id (after 20 '(redisplay)))
         ;;;(write *after-cmds*)
        ;;;(write id)
        ;;;;(update)   ;;;; added by sato
    )
))

(pack (oglwin '.gl :width 300 :height 300)
        :side 'left :expand 'yes :fill 'both)

(pack (frame '.cmdframe) :side 'right :fill 'y)

(button '.quit :text "Quit" :command "exit")
(pack .quit :in .cmdframe :fill 'x)

(radiobutton '.cyltex :text "Cylindrical Coordinates"
   :var 'texmode :value 'cyltex
	:command 
    '(.gl 'eval :disable 'texturegens 
	    :disable 'texturegent) 
)

(radiobutton '.objlinear :text "Object Linear"
   :var 'texmode :value 'objlinear
	:command 
    '(.gl 'eval :texgen 's 'texturegenmode 'objectlinear 
	    :texgen 't 'texturegenmode 'objectlinear 
	    :enable 'texturegens 
	    :enable 'texturegent )
)

(radiobutton '.eyelinear :text "Eye Linear"
   :var 'texmode :value 'eyelinear
	:command 
    '(.gl 'eval :texgen 's 'texturegenmode 'eyelinear 
	    :texgen 't 'texturegenmode 'eyelinear 
	    :enable 'texturegens 
	    :enable 'texturegent )
)

(radiobutton '.checker :text "Checkerboard texture"
   :var 'teximg :value 'checker
	:command
     '(begin  
      ;;(catch (set! img ()))
      (createcheckerimg)
      (.gl 'eval :teximage2d 0 0 'img)
    )
)

(radiobutton '.teapot :text "Teapot Photo texture"
   :var 'teximg :value 'teapot
	:command
    '(begin 
      ;global tk_library
     ;;;( catch (set!  img ()))
     (image 'create 'photo 'img :file 
          (tk-string tk_library "/demos/images/teapot.ppm"))
     (.gl 'eval :teximage2d 0 0 'img)
    )
)



(pack .cyltex .objlinear .eyelinear .checker .teapot :in .cmdframe 
	:anchor 'w)

(.checker 'invoke) 
(.cyltex 'invoke)

(.gl 'eval :teximage2d 0 0 'img
	:enable 'depthtest 
	:texparameter 'texture2d 'texturewraps 'repeat
	:texparameter 'texture2d 'texturewrapt 'repeat 
	:texparameter 'texture2d 'texturemagfilter 'nearest 
	:texparameter 'texture2d 'textureminfilter 'nearest 
	:texenv 'textureenv 'textureenvmode 'modulate
	:texgen 's 'objectplane  1 0 0 0
	:texgen 't 'objectplane  0 0 1 0
	:shademodel 'smooth 
	:enable 'texture2d 
	:light 'light0 'ambient 1 1 1 1 
	:light 'light0 'diffuse 1 1 1 1 
	:light 'light0 'position 1 1 1 0 
	:light 'light0 'specular 1 1 1 1 
	:enable 'lighting :enable 'light0 
	:material 'front 'ambient 0.4 0.4 0.4 
	:material 'front 'diffuse 0.5 0.5 0.5 
	:material 'front 'specular 0.5 0.5 0.5 
	:material 'front 'shininess 50 
	:enable 'depthtest 
	:enable 'lighting
)

(define  info (.gl 'gencyl :texgen 0 1 0 1 :polygon 0.5 20
      :plot :transl 0 0 1 :plot))

(define  dlist (list-ref (list-ref info 0) 1))
;;;;;   may be STk's Bug
;;;;  thisb info result should be the list of list
;;;; However , returned plain list!
;;;;
;;; (define  dlist (list-ref info  1))       ;;; For STk  change the above this 
(define yrot 0)
(redisplay)


