/****  error.c
    simple version   ***/
/****   error hook  03.10.14  ***/
/****   E_tcl only returns    
        controlled by *tcl-error*  
***/
/**** 
     New m.c	に対応　03.10.18
     03.12.22   MC version  not use PC
****/
/***  STDOUT->STDERR   04.11.14   ***/

#include "lisp.h"
extern  error_top(),print_pc();
extern  ptr *pc_stack,a_env;
extern ptr M_jsr(),M_exp(),M_funcout();

#define SYMBOLHOME(x)    (CDDDR(x))

extern int evalflag,narg,level;
ptr assq();
extern *MPC;
int error_count;

#ifdef USE_TK
/***  tk_eval.c  **/
extern int tkreturn,conv_level;
extern char tkcmdbuf[];
#endif

static ptr print_error();

error(int em, ptr p)
{
  ptr msg,x,y;
  int type;
  evalflag=0;  /*** clear eval error **/
  x=MAKESINT(em);
  ATOMVAL(a_errno)=x;
  Errno=x;
  error_count++;
  if(debug_level>10||em==E_intrupt){ 
      PRINT("avoid infiny loop");
      newline(STDOUT);
      long_jmp(1,p);  /*** goto top to avoid infinity loop***/
  }
   if(em==E_segm&&error_count>5){
      sprintf(iobuff,"error %x count %d\n",em,error_count);
      lwritestr(STDERR,iobuff);
      print_error(em,p,STDERR);
      long_jmp(1,p);  /*** goto top to avoid infinity loop***/
   }
   /***     exit(999); ***/
  ATOMVAL(a_error_env)=a_env;
  x=ATOMVAL(a_errorhook);
  if(!SREGP(x)&&CLOSUREP(x)){
      /*****   errorhook!!!  *****/
        type=(int)FTYPE(x);
     ATOMVAL(a_errorhook)=CONS(x,a_nil);/*** save but not closure
                 for true error in hook-func  ***/
     if(!(type&LAMBDA)) {
       error(E_nullfunc,x);
     }
     psh(MAKESINT(em));
     psh(p);
     funcall(x,2,a_nil);   /*** Never return if  x include restore-cc ***/
     stack-=2;  /*** Never reach ***/
     /*** hook-chk   OK!  03.12.25 ***/
     /***  printf("errorhook did't work???\n"); ***/
      /** long_jmp(1,p);  goto top ,  No! V2.0 ***/
   }
   sys_error(em,p);
}

sys_error(int em, ptr p)
{
    evalflag=0;  /*** clear eval error **/
  ATOMVAL(a_error_env)=a_env;
   print_error(em,p,STDERR);
#ifdef USE_TK
    s_print_last_tcl(0,a_nil);
#endif
    if(istty){
      /***  Do nothing V2.0 ,  see vm.c   error_top
      if(debug_level)
          long_jmp(debug_jmp,em); 
      error_mctop(em);    ***   MC!  
      ***/
    }
    else
     exit(1);
    /***     long_jmp(0,em);  never reach  V2.0, No jmp  **/
}


static ptr print_error(int em,ptr p,ptr lpath){
 ptr msg;
  msg=assq(MAKESINT(em),CAR(a_errmsg));
  evalflag=0;   /**** error in eval ***/
  if(msg!=a_f) princ(CDR(msg),lpath);
    else{
      lwritestr(lpath," User error ");
       prin1(MAKESINT(em),lpath);
        newline(lpath);  
    }
  if(em== E_unprint){
      sprintf(iobuff," error unprintable object =%x\n",p);
      lwritestr(lpath,iobuff);
   }
  else if(em== E_segm){
     if(p!=a_nil)
        prin1(p,lpath);
     newline(lpath);
  }
  else
    {
      lwritestr(lpath,":  ");
       if(!SREGP(p)&&SYMBOLP(p)){
             prin1(SYMBOLHOME(p),lpath);
             /** newline(STDOUT); ***/
       }
      prin1(p,lpath);
      /***
      if(OBJP(p))
           printf("   obj adress %x attr %x car %x cdr %x \n",p,ATTR(p),CAR(p),CDR(p));
       ***/
     newline(lpath);
    }
  return a_undef;
}

ptr s_print_error(int narg,ptr env){
  ptr num,obj,lpath;
   if(narg==2){
      num=*(stack-2);
      obj=*(stack-1);
      lpath=STDERR;
  }
  else if(narg==3){
      num=*(stack-3);
      obj=*(stack-2);
      lpath=*(stack-1);
  }
 else    
     checknarg(narg-3);
   return print_error(SINT_NUMB(num),obj,lpath);
}

fatal_error(int em, ptr p)
{
  ptr msg;
  msg=assq(MAKESINT(em),CAR(a_errmsg));
  /*** if(msg!=a_f) prin1(CDR(msg),STDOUT); ***/
    /*** prin1(p); ***/
  printf(" Last object %x. *** Fatal!!!  exit *****\n",p);
  s_bye();
  exit(em);
}

ptr s_error(int narg,ptr env){
checknarg(narg-2);
error(SINT_NUMB(*(stack-2)),*(stack-1));
}

ptr s_sys_error(int narg,ptr env){
checknarg(narg-2);
sys_error(SINT_NUMB(*(stack-2)),*(stack-1));
}


