/***  times.c
***/

#include "lisp.h"
#include <time.h>
#include <sys/times.h>

#define TICS 100.0   /****  system depends!!!  ***/

extern ptr MAKEDBL();
extern char *get_date();

/** static  struct tms time_buffer;***/

/****  spent time of  procesee in  msec   ***/
static long tic_time=-1;

double my_time()
{
 long total;
 struct tms time_buffer;
  if(tic_time==-1){
      tic_time=times(&time_buffer);
      return 0.0;
  }
  total=times(&time_buffer)-tic_time;
  /** printf("%d\n",total); ***/
  return (double)total/(double)TICS;
  /** return 1000*(time_buffer.tms_utime + time_buffer.tms_stime)/TICS ; **/
}

/*** return  process used time   sec  ***/
ptr s_times(int narg,ptr env){
  checknarg(narg); 
  return MAKEDBL(my_time());
}

/*** return time in sec from 1970 ***/
ptr s_time(int narg,ptr env){
  checknarg(narg);
  return bignum(time(NULL));
}
/***** return date ascii  ***/
ptr s_date(int narg,ptr env){
time_t n;  /***  unsigned int in 32 bit system , but in 64 bit OS its 64 bit  **/
/**  int n;  **/
  checknarg(narg);
  n=time(NULL);
 /**   printf("s_date %x\n",n);  ***/
  return make_str_c(get_date(&n)); /*** see system.c ***/
}


