/*** biglog.c
***/

#include "lisp.h"
#include <stdio.h>

/***   biglog      */
/***    LOGICAL SUBROUTINE       */

int (*logic)();
int (*Blogic)();

ptr long_logic(up,vp)
  Reg ptr up,vp;
{
    psh(up);
    psh(vp);
    up=(ptr) (* Blogic)(BIGNUM(up),BIGNUM(vp));
    stack-=2;
    return up;
}

ptr logic16(p,q)
  Reg ptr p,q;   /* int  */
{
  return MAKENUM((* logic)(getnum(p),getnum(q)));
}


/***  GMP version OK below ***/
ODDP(up)
  Reg ptr up;
{
  if(SINTP(up)) 
     {
        return (int)up&4;
     }
  if(!BIGINTP(up)) error(E_notint,up);
     return mpz_odd_p(BIGNUM(up));
}

ptr s_oddp(int narg,ptr env)
  
{
   checknarg(narg-1);
    return PRED(ODDP(*(stack-1)));
}

EVENP(up)
  Reg ptr up;
{
  if(INTP(up)) 
     {
        return ((int)up&4)==0;
     }
  if(!BIGINTP(up)) error(E_notint,up);
     return  mpz_even_p(BIGNUM(up));
}

ptr s_evenp(int narg,ptr env)
  
{
   checknarg(narg-1);
    return PRED(EVENP(*(stack-1)));
}
 

