/*** 
  m_opt.c  03.12.20

  a little part of m-opt.ss
  see also comp.c
****/
#define  M_OPT_C

#include "lisp.h"

extern ptr NOP,k_warn;
extern ptr k_load,k_set,k_warn,k_env,k_top,k_lambda,k_macro,k_func,k_tail_jump;
extern ptr k_define,k_jmp,k_label,k_block_out,k_block_in,k_BIND,k_letbind,k_stack_narg;
extern ptr k_lambda_begin,k_lambda_bind,k_IF,k_I,k_call_cc,k_F;
extern ptr k_jsr,k_exit,k_tail,k_frame,k_frame_list;
extern ptr k_lambda_end,k_macro_end,k_imm,k_alloc,k_dealloc,k_reg;


ptr delete_warn(ptr v){
 Reg  ptr *p,x,top;
 int i,n,lab=0,k;

 p=get_vector(v,&n);
 i=0;
 while(i++<n){
  x=*p;
  top=CAR(x);
  if(top==k_warn){
      *p=NOP;
   }
  if(top==k_label){
    k=(int)CADR(x);
    if(k>lab)lab=k;
  }
  p++;
 }
 return (ptr)lab;
}

ptr delete_nop(ptr v){
 Reg  ptr *p,*q,x,top;
 int n,i,k;
 q=p=get_vector(v,&n);
 k=n;
 i=0;
 while(i++<n){
  x=*p++;
  top=CAR(x);
  if(top!=a_f){
      *q++=x;
      k--;
   }
 }
 i=0;
  while(k--){
    *q++=NOP;   /*** must erase ,copied op's ***/
  }
 return v;
}

ptr insert_comp(ptr *p,ptr s){
  Reg ptr x;
  while(1){
    x=*p;
    *p++=s;
    s=x;
    if(CAR(x)==a_f) break;  /***  NOP replaced! no need after even if rest exists !***/
  }   
 return a_undef;
}
  

