
#include "lisp.h"
#include <stdio.h>
#include <ctype.h>
/*  89.6.15 format.c start */
/*  89.7.11 formsk.c start
     for kurikaesi     ****/

#define  KANJIP(x)   (kanji_mode&&((x)&0xff)>127)
     
#define kolon (modeb&1)
#define atto  (modeb&2)

extern int skip_siji;
    /*** introduced 89.7.15**/
    
extern  Uchar *modef();
Uchar *sfpara();

int skformat(ctrl,start,total)
   ptr ctrl;
   int start,total;
 {
   Reg int n,len;
   Reg Uchar *p,*r;
   Reg ptr q;   
   int siji_char,modeb,para[10];
   int esc=0;
    /** kanji_mode=(CAR(a_kanji)!=a_nil); *****  kanji 89.8.30****/
      para[0]=0;   
      len=total;
   loop:
      p=FWSTR(ctrl)+start+total-len;
     skip_siji=0;   /*** for return information 89.7.17 */
     if(len==0) return len;
     if(len<0) form_err(E_syntax,ctrl);
     if(esc||(*p!='~'))
      {
         if(esc) esc=0;
         else
           if(KANJIP(*p)) esc=1;
        p++;
        len--;
        goto loop;
      }
       n=0;
       r=p;
       r++; /* skip ~ */
        r=sfpara(r,para);
     modeb=0;
     r=modef(r,&modeb);
     skip_siji=siji_char=*r++;
     len-=(r-p);
     switch(siji_char)
      {
        case '(':  /*** 89.7.15  ****/
                 len=skformat(ctrl,start+total-len,len);
                  break;
        case '{':  /*** 89.7.15  ****/
                 len=skformat(ctrl,start+total-len,len);
                  break;
        case '<':  /*** 89.7.16  ****/
                  n='>';
                  goto skip;
        case '[':  /*** 89.7.15  ****/
                  n=']';
            skip:
                 while(1)
                 {
                   /***  skip all clause ***/
                 len=skformat(ctrl,start+total-len,len);
                 if(skip_siji==n) break;
                 if(skip_siji!=';') 
                        form_err(E_syntax,ctrl);
                 }
                  break;
        case ']':
        case '}':
        case ')':
        case '>':
                  return len;
         default:
               goto loop;
      }
    goto loop;     
 }
Uchar *sfpara(p,para)
   Reg unsigned char *p;
   Reg int  *para;
  {
   Reg int n,sign;
   Reg unsigned char c;
   
   n=0; /* need! */
  loop:
     sign=0;
    if(n>7) form_err(E_syntax,a_nil);
    while((c=*p)==' ') ++p;
    if(c==',')
     {
       p++;
       n++;
       goto loop;
     }
    if(c=='+'||c=='-')
      {
         sign=c;
         c=*++p;
      }
    if(isdigit(c))
     {
       while(isdigit(*p))
       {
         p++;
       }
       goto loop;
     }
    if(sign)
       {
        form_err(E_syntax,a_nil);
       }
    if(c=='v'||c=='V'||c=='#')
     {   
     }
    else if(c=='\'')
     {
       ++p;
     }
    else
        return p;
    ++p;
  goto loop;
 }
 
