/***  formsub.c
***/

#include "lisp.h"
#include <stdio.h>
#include <ctype.h>
#include <string.h>
/*   format.c start */
/****   format.c separated to
     format.c  formsub.c   ****/
#define PAGE 12
#define SHIFT  10000   /*  for char-parameter ***/
#define UNGIVEN  -1000000000
    /*  c is default value */
#define  para_c(n,c)  ((para[n]!=UNGIVEN)?(para[n]+SHIFT):c)
#define  para_d(n,c)  ((para[n]!=UNGIVEN)?para[n]:c)
 

#define atto  (modeb&2)
/** extern int col_loc[];    89.7.26 */
extern ptr _float();

/*** #define pos(s)  POS_OUT(s)   col_loc[n]  position not support for ss ***/

 ptr check_a();
char *fpara(),*modef();

/***   justification ****/
just(stream,argbuf,radix,para,modeb)
  Reg ptr stream;
  ptr *argbuf;
  int radix,*para,modeb;
{
   Reg int n,len,bk,amari;
   Reg int w,cinc,min,pad_c,wd;
   /***  total length ****/
   n=radix;
   while(n--)
    {
     len+=STRLEN(argbuf[n]);
    }
    /****/
    wd=para_d(0,0);
    cinc=para[1];
    if(cinc<=0) cinc=1;  /*** increment ***/
    min=para_d(2,0);
      /***   kuuhaku wo oku basyo no kazu  ***/
      bk=radix-1;
      bk=radix-1+(atto!=0);
      if(bk==0)
       {
         bk=1;/***  radix==1&& modeb==0 ***/
       }
   w=len+min*bk;
   if(w>wd)
      {
         w=wd+((w-wd-1)/cinc)*cinc+cinc;
         amari=0;
      }
   else
     {
          min+=(wd-w)/bk;
          amari=wd-(len+min*bk);
     }
   pad_c=para_c(3,' ');
   for(n=0;n<radix;n++)
     {
        if(n)
           pad(pad_c,min+(amari-->0),stream);
        fprinc(stream,*argbuf++);
     }
   if(atto)
      pad(pad_c,min+(amari-->0),stream);
}

formA(p,stream,para,modeb)
   Reg ptr p;
   Reg ptr stream;
   int *para,modeb;
 {
    /****   6.15   only  ~w@A   ***/
    
  Reg int w,n,pad_c;
  Reg int minpad,colinc;
   psh(p);   /***   needs!! because p is not pshed
                  & lwrite maybe string-output and may occur gbc! ***/
   w=para_d(0,0);
   colinc=para_d(1,1);
   minpad=para_d(2,0);
   pad_c=para_c(3,' ');
  /*** printf("formA w %x colinc %x  minpad %x  pad_c %x\n",w,colinc,minpad,pad_c); ***/

   n=STRLEN(p);
   if(!atto)
       fprinc(stream,p);
   if(minpad)
    {
      pad(pad_c,minpad,stream);
      w-=minpad;
    }
   w-=n;
   if(colinc<=1)
      pad(pad_c,w,stream);
   else 
     while(w>0)
      {
      pad(pad_c,colinc,stream);
      w-=colinc;
      }
         
   if(atto)
       fprinc(stream,p);
      pull();
      return;
 }


pad(c,n,stream)
 Reg int c,n;
 ptr stream;
{
if(n<=0) return;
  while(n--)
   {
     WRITE_CHAR(c,stream);
   }
 }

formD(p,stream,para,modeb)
   Reg ptr p;
   Reg ptr stream;
   int *para,modeb;
 {
    /****     only  ~w,pad,keta:@D   ***/
  Reg int w,pad_c,sig,k,keta;
  Reg Uchar *q;
  int n;
   psh(p);   /***   needs!! because p is not pshed
                  & lwrite maybe string-output and may occur gbc! ***/
   w=para_d(0,0);
   pad_c=para_c(1,' ');
   q=get_string(p,&n);
   /***  printf("formD %s\n",q); ***/
   sig=(*q!='-');
    if(atto&&sig) n++;
      pad(pad_c,w-n,stream);
     if(atto&&sig) WRITE_CHAR('+',stream);
    fprinc(stream,p);
      pull();
      return;
 }

formFF(c,stream,para)
   Reg int c;
   ptr stream;
   int *para;
 {
  Reg int w;
   w=para_d(0,1);
   while(w--)
     WRITE_CHAR(c,stream);
 }

formTAB(stream,para,at)
   Reg ptr stream;
   int *para,at;
 {
  Reg int col,colinc,w,n,k;
   col=para_d(0,1);
   colinc=para_d(1,1);
    if(at)
     {
        while(col--)
         WRITE_CHAR(' ',stream);
        col=get_pos(stream)%colinc;
        col=col?colinc-col:0; 
        while(col--)
         WRITE_CHAR(' ',stream);
     }
    else
     {
      n=get_pos(stream);
      if(n<col)
       { 
        w=col-n;
          while(w--)
            WRITE_CHAR(' ',stream);
       }
      else if(colinc)
        {
          k=1+(n-col)/colinc;
          w=col+k*colinc;
          while(w<=n) w+=colinc;
          w-=n;
          while(w--)
            WRITE_CHAR(' ',stream);
        }
     }
 }

/*** #define MAXK  15    53 bit < 16 keta ****/
/** static int maxk=MAXK; **/
#define maxk  15   /***  53 bit < 16 keta ****/

static char xf[256],wf[256],vf[256];
static char f_form[80],sisu[50];
static int val_sisu,yuuko;
static double f_val;
char *zerot(),*marume();

formE(stream,para,modeb)
   Reg ptr stream;
   int *para,modeb;
 {
    /*** E-format ***/
    /***  89.7.20  scale factor support ***/
     char *pr_E();
  Reg int w,d,n,sig,expc;
  Reg char *p;
  Reg double x;
   w=para_d(0,0);
   d=para_d(1,yuuko-1);
       if(d<=0) d=1;

   if(p=pr_E(d,para_d(2,0),expc=para_c(6,'e'),para_d(3,1))) 
    {
      sig=(*(p+1)=='0'&&*(p+3)!=expc);  /***  0.xxx   0 is syouryaku dekiru */
      if((*p=='+')&&(atto==0))
         p++;
      n=strlen(p);
      if(w)
       {
         if(n>w)  
          {
            if(sig&&(--n==w))
             {
                 /***   0.1e+0 --->.1e+0  ***/
               if(*p++!='0') 
                {
                  *p=*(p-1);
                }
             }
            else
               goto over;
          }
        pad(para_c(5,' '),w-n,stream);
       }
     owari:
      pr_cstr(stream,p);
     return;      
    }
   over:
   /** 90.3.29 **/
      sprintf(f_form,"%%.%dE",maxk-1);
       sprintf(p=xf,f_form,f_val);   
     if(n=para_c(4,0))
      {
        if(w==0) w=strlen(p);
          pad(n,w,stream);
      }
     else
      {
      goto owari;
      }
 }
          

char *pr_E(d,e,expc,k)
   Reg int d,e,expc,k;
 {
   Reg int n,dc,scale;
   Reg char *p,*q;
    /***  d=syousuubu-keta  e=sisuu-keta expc=exp-character(e,E,d,D...) ***/
    /*** k=scale   89.7.20***/
      /***   k,d no settei  ***/
     
     if(k>0)
      {
        d+=1-k;
      }
     else
       d+=k;
     if(d<0)
        {
          return NULL;   /*** parame-ta miss -->overflow to minasu! ***/
        }
     dc=d;
   if(dc>maxk) dc=maxk;
   d-=dc;
   p=xf;
   q=wf;
   *q++=*p++;  /*  +-  */
     scale=val_sisu-k+1;
  /***  n is  yuukou keta suu  ***/
  if(k>0)
     n=k+dc;   /*** xxx.sss = k.dc  ****/
  else
     n=dc;    /***  0.000ssss= 0.k*0 dc   ***/
   p=marume(n);
   if(*p++!='0')
    {   /***  all keta-agari ***/
       --p;
       scale++;
    }
  if(k>0)
   {
     while(k--)
        *q++=*p++; 
           *q++='.';
    }
  else
   {
           *q++='0';
           *q++='.';
       while(k++)
           *q++='0';
   }
        while(dc--)
           *q++=*p++;
     while(d--)
       *q++='0';
   p=index(p,'e');
    /* strcpy(q,p); */
    *q++=expc;
     if(makesisu(q,e,scale))
      {
       return wf;
      }
     else
       return NULL;
 }

makesisu(q,e,v)
  Reg char *q;
  Reg int e,v;  /* keta suu */
 {
  Reg char *r=sisu;
  Reg int n;
   *r='+';
   sprintf(r+(v>=0),"%d",v);
   *q++=*r++;
  if(e)
   {
     n=strlen(r);
      if(n>e) return NO;
        while(n++<e)
         *q++='0';
    }
   strcpy(q,r);   
   return YES;
 }
    
char *pr_F(d,e)
   Reg int d,e;
 {
   Reg int n,scale;
   Reg char *p,*q;
    /***  d=syousuubu-keta  e=scaling ***/
   p=xf;
   q=wf;
   *q++=*p++;  /*  +-  */
   scale=val_sisu+e+1;
   if(scale>80||scale<-80) 
     {
        /**** overflow ****/
       *q++=*p++; 
       *q++='.';
        while(--yuuko>0)
          *q++=*p++;
       *q++='E';
       if(--scale>=0) *q++='+';
       sprintf(q,"%d",scale);
       return NULL; /**** overflow ****/
     }
  /***  n is  yuukou keta suu  ***/
     n=scale+d;   /*** xxx.sss = scale.dc  ****/
   if(n>=0) p=marume(n);
   if(*p++!='0')
    {   /***  all keta-agari ***/
       --p;
       scale++;
    }
   if(scale>0)
    {
        while(scale--)
          *q++=*p++;
        *q++='.';
        while(d--)
          *q++=*p++;
    }
   else
    {
     *q++='0';
     *q++='.';
     d+=scale;
      if(d<0)  /***  <= wo < nisita. 89.7.20 */
           q=zerot(q,d-scale);
      else 
       {
           q=zerot(q,-scale);
        while(d--)
          *q++=*p++;
       }
     }
    *q=0;
       return wf;
 }

char *zerot(q,d)
  Reg char *q;
  Reg int d;
 {
   while(d--)
     *q++='0';
   return q;
 }
formF(stream,para,modeb)
   Reg ptr stream;
   int *para,modeb;
 {
    /*** F-format ***/
     char *pr_F();
  Reg int w,d,n,sig;
  Reg char *p,*q;
  Reg double x;
  double fabs(),log10(),floor();
  
   w=para_d(0,0);
   if((d=para[1])==UNGIVEN)
    {
      d=yuuko;
     /* n=1+(int)floor(log10(fabs(x))); ***/
       n=val_sisu+1;
     if(d<n) d=n;
     d-=n;
     if(d==0) d=1; /** 91.8.8**/
    }
  /* if(d==0) d=1; */
  retry:
   p=pr_F(d,para_d(2,0));
    if(p==NULL)
     {
      p=wf+((*wf=='+')&&(atto==0));
      goto over;
     }
      sig=(*p=='+')&&(atto==0);
      if(sig)
         p++;
      n=strlen(p);
      if(w)
       {
         if(n>w)  
         {
            if(para[1]!=UNGIVEN)
                 goto over;
             else
              {
                /*** 89.7.20   justification to w ***/
                 d-=(n-w);
                 if(d<=0) goto over;
                 goto retry;
                 /* q=p+w;
                 n=*q;
                 *q--=0;
                 if(n>'4') 
                      *q+=1;  *** 4 sya 5 nyuu ***
                 n=w;
                */
             }
          }
        pad(para_c(4,' '),w-n,stream);
       }
      pr_cstr(stream,p);
     return;      
   over:
     if(n=para_c(3,0))
      {
        /* if(w==0) w=strlen(p);*/
          pad(n,w,stream);
      }
     else
      pr_cstr(stream,p);
 }
formG(stream,para,modeb)
   Reg ptr stream;
   int *para,modeb;
 {
    /*** G-format ***/
  Reg int w,d,n,ww,e,ee,dd,q,omit_f;
  /** 89.7.23  changed ***/
  
   w=para_d(0,0);
   d=para_d(1,0);
   q=yuuko;
   n=val_sisu+1;
  /* printf("yuuko=%d n=%d\n",q,n);   */
  if(e=para_d(2,0))
      ee=e+2;
    else
      ee=4;
   ww=w?w-ee:0;
   if(para[1]==UNGIVEN)
    {
       if(n>q) d=n;
       else
          d=q; 
    }
      dd=d-n;
  /* printf("d=%d dd=%d\n",d,dd);   */
    if(dd<0||-3>n||n>7)  
          goto Ek;
    if(para[0]!=UNGIVEN&&(ww<((n>0)?d+2:dd+3)))
          goto Ek;
       if((para[1]==UNGIVEN)&&(dd<=0)) dd=1;
       para[0]=ww;
       para[1]=dd;
       para[2]=UNGIVEN;
       para[3]=para[4];
       para[4]=para[5];
       formF(stream,para,modeb);
       pad(' ',ee,stream);
      return;
    Ek:
       /* para[1]=d; */
       formE(stream,para,modeb);
 }

f_init(dp)
  Reg ptr dp;
  {
    /***   _float && ~A support ***/
    if(RATIOP(dp)) dp=_float(dp);
    else if(!DOUBLEP(dp)) return -9999;
    return f_init_set(dp);
   }

f_init_set(dp)
  Reg ptr dp;
  {
    Reg double x;
    Reg int n,sig;
     Reg char *p;
     
     f_val=x=*(double *)dp;
    if(sig=(x<0)) x=-x;
   sprintf(f_form,"%%.%dE",n=maxk-1);
   sprintf(xf,f_form,x);   
   p=xf+(++n);
   while(*p--=='0')
     n--;
   xf[1]=*xf;
   *xf=sig?'-':'+';
  /* printf("n=%d\n",n);   */
    p=xf+maxk+2;   /***  sisuubu ****/
    val_sisu=atoi(p);
   return yuuko=n;
  }

char *marume(n)
  Reg int n;   /*** ketasuu   ***/
{
 /****   xf-->vf ***/
 /*****   031415   or 100000 (+999999)  **/
 /****   so *vf==0 is usual  ****/
   Reg int k,c;
   Reg char *p,*q;
   p=xf;
   q=vf;
   *q++='0';
   *p++;  /** skip + ***/
   k=yuuko;
   if(n>=k)
   {
     while(k--)
       *q++=*p++;
     n-=k;
       while(n--)
           *q++='0';
   }
  else
   {
    while(n--)
           *q++=*p++;
        /***  4 sya 5 nyuuu!!!! ****/
     if(*p>'4')
      {
         while(*--q=='9')
            {
              *q='0';
            }
          *q+=1;
       }
    }
  return vf;
 }

