/****   history.c
  combination history
  for debug loop  in m.c
  created  2003.10.21
 2003.12.23    for mc error,  top var load is history !!!
****/
#define  HITORY_C

#include "lisp.h"
#include "stdio.h"

ptr chistory[HISMAX];
ptr *hisnext,*hisend;
int histotal;

init_his(){
 hisnext=chistory;
 hisend=hisnext+HISMAX;
 histotal=0;
 }

/***  cyclic psh   ***/
ptr psh_his(ptr p){
histotal++;
if(hisnext==hisend) hisnext=chistory;
return *hisnext++=p;
}

static ptr get_his(int n){
/***  n=1,2,...... HISMAX ***/
/***  n=1 means last pshed  ***/
ptr *p=hisnext;
if(n>HISMAX||n>histotal) return NULL;
p-=n;
while(p<chistory) p+=HISMAX;
return *p;
}


print_history(int k, int n){  /***  k<n  ***/
 ptr p;
 if(n>histotal) n=histotal;
 if(k>n) return;
 PRINT("Func & Macro (:T ) history\n");
while(n>=k){
 p=get_his(k);
 if(p==NULL) return;
 sprintf(iobuff,"his %d: ",k);
 PRINT(iobuff);
 prin1(p,STDOUT);
 newline(STDOUT);
 k++;
 }
}

print_his(int n){
 int k=1;
 ptr p;
 if(n<0) n=-n;
 if(n>histotal) n=histotal;
 print_history(1,n);
}

static ptr history_list()
{
 int k=1;
 int n;
  ptr p,res=a_nil;
  n=histotal;
  
if(n>HISMAX) n=HISMAX-1;
while(n){
 p=get_his(n--);
 res=SCONS(p,res);
 }
 return res;
}
 
ptr s_function_his(int narg,ptr env){
 int n;
  checknarg(narg);
  return history_list();
}
ptr s_reset_his(int narg,ptr env){
  checknarg(narg);
 init_his(); 
  return a_nil;
}
/****
  n=SINT_NUMB(*(stack-1));
  if((n>HISMAX)||(n<0)) return a_undef;
  print_his(n);
  return a_undef;
}
****/
/*** printf("histotal %d \n",histotal); ***/



