#include "lisp.h"
extern void checknarg();
extern void init_sub();

extern ptr gen_add(),gen_sub(),gen_minus(),gen_mul(),gen_div(),gen_mod(); 
extern ptr s_quotient(),gen_remain();
extern ptr
 s_float(),
 s_floor(),
 s_truncate(),
 s_ceiling(),
 s_round(),
 s_ffloor(),
 s_ftruncate(),
 s_fceiling(),
 s_fround(),

 s_sin(),
 s_cos(),
 s_tan(),
 s_sqrt(),
 s_isqrt(),
 s_cis(),
 s_phase(),
 s_makepolar(),
 s_signum(),
 s_asin(),
 s_acos(),
 s_atan(),
 s_exp(),
 s_expt(),
 s_log10(),
 s_log2(),
 s_log(),
 s_sinh(),
 s_cosh(),
 s_tanh(),
 s_asinh(),
 s_acosh(),
 s_atanh(),
 s_random(),
 s_make_random(),
 s_random_statep(),
  s_gcd(),
  s_lcm(),

 gen_and(),
 gen_ior(),
 gen_xor(),
 gen_eqv(),
 gen_nand(),
 gen_nor(),
 gen_andc1(),
 gen_andc2(),
 gen_orc1(),
 gen_orc2(),
 gen_not(),
 gen_ash(),
 s_logcount(),
 s_loglength(),
  s_logbitp(),  
  s_logtest(),  
  s_realpart(),
  s_imagpart(),
  s_complex(),
  s_conjugate(),
  s_rationalize(),
  s_rational(),
  s_rationalp(),
  s_numerator(),
  s_denominator(),
s_exact2inexact(),
s_inexact2exact(),

 s_g_eq(),
 s_g_gt(),
 s_g_lt(),
 g_ne(),
 s_g_ge(),
 s_g_le(),
 g_max(),
 g_min(),
 g_sub1(),
 g_add1(),
 g_abs(),
 g_zerop(),
 g_minusp(),
 s_oddp(),
 s_evenp(),
 g_sign(),
 g_plusp();


struct  sys_subr  math_func[]=
  {
{"+", gen_add, 0,1},
{"-", gen_sub, 0,1},
{"*", gen_mul, 0,1},
{"/", gen_div, 0,1},
{"1+", g_add1, 1,0},
{"1-", g_sub1, 1,0},
{"<", s_g_lt, 2,1},
{"<=", s_g_le, 2,1},
{"=", s_g_eq, 2,1},
{">", s_g_gt, 2,1},
{">=", s_g_ge, 2,1},
{"abs", g_abs, 1,0},
{"magnitude", g_abs, 1,0},
{"acos", s_acos, 1,0},
{"acosh", s_acosh, 1,0},
{"add1", g_add1, 1,0},
{"ash", gen_ash, 2,0},
{"asin", s_asin, 1,0},
{"asinh", s_asinh, 1,0},
{"atan", s_atan, 0,1},
{"atanh", s_atanh, 1,0},
{"ceiling", s_ceiling, 0,1},
{"fceiling", s_fceiling, 0,1},
{"cis", s_cis, 1,0},
{"cos", s_cos, 1,0},
{"cosh", s_cosh, 1,0},
{"denominator", s_denominator, 1,0},
{"even?", s_evenp, 1,0},
{"exp", s_exp, 1,0},
{"expt", s_expt, 2,0},
{"float", s_float, 0,1},
{"floor", s_floor, 0,1},
{"ffloor", s_ffloor, 0,1},
{"gcd", s_gcd, 0,1},
{"imag-part", s_imagpart, 1,0},
{"isqrt", s_isqrt, 1,0},
{"lcm", s_lcm, 0,1},
{"log", s_log, 0,1},
{"log10", s_log10, 1,0},
{"log2", s_log2, 1,0},
{"logand", gen_and, 0,1},
{"logbitp", s_logbitp, 2,0},
{"logtest", s_logtest, 2,0},
{"logcount", s_logcount, 1,0},
{"integer-length", s_loglength, 1,0},
{"logeqv", gen_eqv, 0,1},
{"logior", gen_ior, 0,1},
{"lognot", gen_not, 1,0},
{"logxor", gen_xor, 0,1},
{"lognand", gen_nand, 2,0},
{"lognor", gen_nor, 2,0},
/***
{"logandc1", gen_andc1, 2,0},
{"logandc2", gen_andc2, 2,0},
{"logorc1", gen_orc1, 2,0},
{"logorc2", gen_orc2, 2,0},
***/
{"random-seed", s_make_random, 1,0},
{"max", g_max, 0,1},
{"min", g_min, 0,1},
{"negative?", g_minusp, 1,0},
{"numerator", s_numerator, 1,0},
{"odd?", s_oddp, 1,0},
{"angle", s_phase, 1,0},
{"make-polar", s_makepolar, 2,0},
{"conjugate", s_conjugate, 1,0},
{"positive?", g_plusp, 1,0},
{"random", s_random, 0,1},
{"rational", s_rational, 1,0},
{"rationalize", s_rationalize, 2,0},
{"real-part", s_realpart, 1,0},
{"round", s_round, 0,1},
{"fround", s_fround, 0,1},
{"sin", s_sin, 1,0},
{"sinh", s_sinh, 1,0},
{"sqrt", s_sqrt, 1,0},
{"tan", s_tan, 1,0},
{"tanh", s_tanh, 1,0},
{"truncate", s_truncate, 0,1},
{"ftruncate", s_ftruncate, 0,1},
{"zero?", g_zerop, 1,0},
{"remainder", gen_remain, 2,0},
{"modulo", gen_mod, 2,0},
{"quotient", s_quotient, 2,0},
{"make-rectangular", s_complex, 2,0},
{"exact->inexact", s_exact2inexact, 1,0},
{"inexact->exact", s_inexact2exact, 1,0},
/***  sslisp ***/
{"complex", s_complex, 2,0},
{"sign", g_sign, 1,0},

 {NULL,NULL,0,0},
 };

init_math(){
init_sub(math_func,SLAMBDA);
}

