/***  read_m.c
***/
#define  READ_M_C

#include "lisp.h"
#include <stdio.h>
#include "clread.h"


/** #define unread_char(x,s)   UNREAD(MAKECHAR(x),s) **/
/***
#define  constituent  1  
#define  space        3
#define  m_escape     5
#define  s_escape     7
#define  t_macro      9
#define  non_t_macro 11
#define  illegal    129
#define ismacro(x) ((x==t_macro)||(x==non_t_macro))
*****/
/*** 
#define  constituent  0
#define  space        1
#define  m_escape    34
#define  s_escape     2
#define  macro        4
#define  non_t_macro  36
#define  illegal      64
***/
/*** #define is_macro(x)   ((x)&macro) **/
/** #define is_non_t(x)   (((x)&non_t_macro)==non_t_macro)**/
/** #define is_t_macro(x)   (((x)&non_t_macro)==macro) **/


ptr mxtoken(),extoken(),g_read(),makestring_p();
extern int loc_tok;


/** #define close_tok()   makestring_p(tokstr,loc_tok)**/

/*   all macro subroutines are here  ***/

ptr s_rm_quote(int narg, ptr env)
   
 {
   Reg ptr p,lpath;
     lpath=*(stack-1);
     checknarg(narg-1);
     p=g_read(lpath);
     return CONS(a_quote,CONS(p,a_nil));
 } 

ptr s_rm_back_q(int narg, ptr env)

 {
   Reg ptr p,lpath;
     lpath=*(stack-1);
     checknarg(narg-1);
     p=g_read(lpath);
     return CONS(a_quasi_quote,CONS(p,a_nil));
 }

ptr s_rm_komma(int narg, ptr env)

 {
   Reg ptr p,lpath,c;
     lpath=*(stack-1);
     checknarg(narg-1);
     c=read_char(lpath);
     if(CHAR_CODE(c)=='@'){
         p=g_read(lpath);
          return CONS(a_unquote_splice,CONS(p,a_nil));
     }
     unreadchar(c,lpath);
     p=g_read(lpath);
     return CONS(a_unquote,CONS(p,a_nil));
 }

ptr s_rm_remark(int narg,ptr env)
   
 {
      Reg ptr lpath,x;
        lpath=*(stack-1);
     checknarg(narg-1);
  while(1)
  {
     x=read_char(lpath);
     if(x==MAKECHAR('\n')||x==SEOF) return a_undef;
  }
 }

ptr s_rm_right_p(int narg,ptr env)
  
 {
    rm_error=E_par; 
    return a_undef;  
 }

ptr s_rm_left_p(int narg,ptr env)
 {
   Reg ptr lpath,x,ret,ret2;
   Reg int i,err;
     lpath=*(stack-1);
     checknarg(narg-1);

     x=CONS(a_nil,a_nil);
    psh(x);

   loop:
       ret=g_read(lpath);
       /*** printf("gread %x\n",ret); ***/
          if(ret==SEOF)
            {
            /*** 89.6.1     ( .... EOF!!  ****/
              rm_error=E_eof;
              goto e_quit;
            }
     if(rm_error)  
      {
        if(rm_error==E_par){
             rm_error=0;
             goto quit;
        }
        else if(rm_error==E_dot){
             rm_error=0;
             ret=g_read(lpath);
             rm_error=0;
            ret2=g_read(lpath);
             err=(long)ret;
            if(rm_error==E_par){
               /***   dot pair ***/
               rm_error=0;
               CDR(x)=ret;
               goto quit;
            }
            else{
               rm_error=E_dot;
              ret=ret2;
              goto e_quit;
            }

        }
        else
            goto e_quit;
      }
    if(ret==a_undef) goto loop;
       /*** printf("gread push %x\n",ret); ***/
    x=CDR(x)=CONS(ret,a_nil);
   goto loop;
 quit:
        pull();
        x=*stack;
        /*** x=*pull(); ***/
        /*** printf("read_m  return %x\n",CDR(x))  ***/;
        return CDR(x);
 e_quit:
     error(rm_error,ret);
}
  
ptr s_rm_str(int narg,ptr env)
   
 {
      Reg ptr type;
      Reg ptr c,lpath;
     lpath=*(stack-1);
     checknarg(narg-1);
    loc_tok=0;
  loop:
     c=read_char(lpath);
     if(c==SEOF) 
       {
         /* close_str(token_lpath); */
         error(E_syntax_read,c);
       }
     if(c==MAKECHAR('"'))
        {
          return close_tok();
        }
     type=get_type(c);
    if(type==s_escape)
     {
      c=read_char(lpath);
        /* res=addtoken(res,x);*/
        /***    \^G enable 
        if(x=='^')
         {
            x=toupper(read_char(lpath))-'@';
            if(x<0) x=0x7f; *** del = \^? ***
         }
       ***/
        add_tok(c);
       goto loop;
     }
    if(type==illegal)
       {
         error(E_ill_char,c);
       }
     add_tok(c);
       /*  lwritec(x,token_lpath);*/
    goto loop;
}
/***
ptr g_skip()
 {
  Reg ptr x;
     do{
       x=inchar();
       } while((x!=SEOF)&&(get_type(x)==space));
   return x;
 }
***/
 /*** see backq.c 91.9.12 ***/




