/***  tk_linkvar.c
***/
#define  TK_LINKVAR_C

#include "lisp.h"
#include <tcl.h>

extern Tcl_Interp *myInterp;
extern ptr EUC_UTF(); /*** utf8.c **/
extern ptr UTF_EUC(); /*** utf8.c **/

ptr make_tklink(ptr name,ptr str,int strflag){
ptr x;
char *p,*q,*r;
int n;
x=new_cell(TKOBJ);
CDR(x)=SCONS(a_nil,PNAME(name));
ATTR(CDR(x))=TKOBJ; /*** needs for gbc  ***/
p=(char *)get_string(PNAME(name),&n);
if(strflag)
  CAR(x)=(ptr)STRING;
else 
  CAR(x)=(ptr)(STRING|BOOLEAN); /*** to be modify  ***/
psh(x);
  if(SREGP(str)||!STRINGP(str)) str=ss_tkstr(str,a_nil,NO);
CADR(x)=NULL; 
Tcl_LinkVar(myInterp, p,(char *)( &CADR(x)),TCL_LINK_STRING);
set_tklink(x=*pull(),str);
return x;
}

ptr set_tklink(ptr obj,ptr str){
ptr x;
char *p,*q,*r;
int n;

  /** if(SREGP(str)||!STRINGP(str)) str=ss_tkstr(str,a_nil,NO); ***/
  if(SREGP(str)||!STRINGP(str)||((long)CAR(obj)!=STRING))
         str=ss_tkstr(str,a_nil,NO); 
  else {
/****    we need euc->utf8   ***/
      /*** pure string ***/
      p=(char *)CADR(obj);
      if(p) Tcl_Free(p);
       /** q=get_string(str,&n); ***/
       /*** new   ->utf ***/
       /** str=EUC_UTF(q,n);  ***/
       if(kanji_mode==2) str=EUC_UTF(str); 
       q=(char *)get_string(str,&n);
       /***  new end ***/
       r=Tcl_Alloc(n+1);
       CADR(obj)=(ptr )r;
       while(n--) *r++=*q++;
        *r=0;
       p=(char *)get_string(CDDR(obj),&n);
       Tcl_UpdateLinkedVar(myInterp,p); /*** This needs when changed in C ***/
       return obj;
  }
  x=CDR(CDR(obj));  /*** PNAME(name)  ***/
  x=str_append(a_str_set,x);
  psh(x);
  *(stack-1)=x=str_append(x,a_str_space);
  *(stack-1)=x=str_append(x,str);
  p=(char *)get_string(x,&n);
  tcleval(x,p,n);  
  pull();
  return obj;
}

static tkunlink(ptr obj){
 char *p;
 int n;

 if(SREGP(obj)||(ATTR(obj)!=TKOBJ)) error(E_nottklink,obj);
  p=(char *)get_string(CDDR(obj),&n);
  Tcl_UnlinkVar(myInterp,p);
  p=(char *)CADR(obj);
   if(p) Tcl_Free(p); 
   CADR(obj)=NULL;
}
 
/*** 
  p=CADR(obj);
  Tcl_Free(p);
  q=get_string(str,&n);
  CADR(obj)=r=Tcl_Alloc(n+1);
  while(n--) *r++=*q++;
  *r=0;
  return obj;
}
****/

ptr get_tklink(ptr obj){
ptr x,y;
char *p,*q,*r;
int n;
  p=(char *)CADR(obj);
  if(p==NULL) return a_nullstr;
  n=(long)CAR(obj);
  if(n&STRING){  
    x=make_str_c(p);
    psh(x);
    y=str2number(x,10);
    pull();
    if(y!=a_f) {
     if(y==ZERO&&(n&BOOLEAN)) return a_f; /**** offvalue ****/
     return y;
    }
    if(kanji_mode==2) return UTF_EUC(x);
    return x;
  }
  return get_ss_obj(p,-1);  /**** 04.10.20 level  -1***/
  /*** return get_ss_obj(p,0);  05.1.15  level 0    may be No good for google ssweb***/
    x=make_str_c(p);
  if(kanji_mode==2) return UTF_EUC(x);
  return x;
}

ptr s_make_tklink(int narg,ptr env){
 Reg ptr v,name;
 checknarg(narg-2);
 name=*(stack-2);
 if(SREGP(name)||!SYMBOLP(name)) error(E_notsymb,name);
 v=*(stack-1);
 /** if(!STRINGP(v)) error(E_notstr,v); **/
  v=make_tklink(name,v,1); /**** とりあえず ***/
  ATOMVAL(name)=v; 
 return v;
}

ptr s_tkunlink(int narg,ptr env){
 Reg ptr v,name;
 checknarg(narg-1);
 name=*(stack-1);
 if(SREGP(name)||!SYMBOLP(name)) error(E_notsymb,name);
  tkunlink(ATOMVAL(name)); 
  ATOMVAL(name)=a_unbdd;
 return a_undef;
}

ptr s_tklinkp(int narg,ptr env){
 Reg ptr name;
 checknarg(narg-1);
 name=*(stack-1);
 if(SREGP(name)) return a_f;
 if(!SYMBOLP(name)) return a_f;
  name=ATOMVAL(name);
 if(SREGP(name)) return a_f;
 return PRED(ATTR(name)&TKOBJ);
}
/***  trace tkvar  04.7.20  ***/
/*** s is tklink***/
/*****
trace_tkvar_prev(ptr s)  
{
     lwritec(STDOUT,'V');
           lwritec(STDOUT,'=');
           prin1(get_tklink(s),STDOUT);
           newline(STDOUT);
}

trace_tkvar_now(ptr s)
{
     lwritec(STDOUT,'N');
           lwritec(STDOUT,'=');
           prin1(get_tklink(s),STDOUT);
           newline(STDOUT);
}
****/
 
  
 
 
