/****  ss cmd 
    tk_ss.c 
   last modified   03.11.3
***/

#include "lisp.h"
#define ECHO   if(tcl_echo)

#include <tcl.h>
#include <string.h>

extern ptr *pc_stack,vm_eval();

/*
* Declarations for application-specific command procedures
*/
int tk_ssCmd(ClientData clientData,
				Tcl_Interp *interp,
				int argc, char *argv[]);
/*
* The Initialization procedure that is called when
* the package is loaded.
*/
/****
int tk_ssInit(Tcl_Interp *interp) {
	Tcl_CreateCommand(interp, "ss", tk_ssCmd,
			(ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
	return TCL_OK;
}
****/
	/** Tcl_PkgProvide(interp, "ss", "1.1");***/


/*
* This implements the ss Tcl command. With two arguments
* the command returns a integer.
*   ss <obj-adress> <conversion-level>
*/

/***  for 64 bit OS  2011.8.18  ***/
static long get_ptr(char *nums){
  long x=0;
  int c,sgn=0;
  while(*nums==' ') nums++;
  if(*nums=='-'){
     sgn=1;
   }
  while(c=*nums++){
    x=x*10+c-'0';
  }
  if(sgn) return -x;
  return x;
}

int
tk_ssCmd(ClientData clientData, Tcl_Interp *interp,
		int argc, char *argv[])
{
	/** int res;  ***/
	long res;  /** for 64 bit OS  **/
        int  error,arg,lev,dump;
        char *p;
        ptr x,env=a_nil,v;
        int n;
       ECHO
          printf("ssCmd enter\n");
       // error = Tcl_GetInt(interp, argv[1], &res);
      /***  error = Tcl_GetLong(interp, argv[1], &res);   for 64 bit OS 2011.8.18  
       But , this seems not implemented for Tcl8.5  
      ***/
        /***
          if (error != TCL_OK) {
                        return error;
           }
        ****/
        res=get_ptr(argv[1]);
        x=(ptr)res;
       error = Tcl_GetInt(interp, argv[2], &lev);
          if (error != TCL_OK)
                        return error;
	sprintf(interp->result, "%ld %d", res,lev); /***  Max 200 bytes P.598 ***/
         if(tcl_echo)
            printf(" ss result %s\n",interp->result); 
         dump=(lev==-4000);
        if(OBJP(x)){
             if(dump) lev=0;  /***more detail    txt 'dump :command ***/
             psh(x);
             if(CLOSUREP(x)){
                  /****   :command (lambda () ......)    ****/
                 env=FENV(x);
                 arg=3;
                 *(stack-1)=x=SCONS(x,a_nil);
                 while(argc-->3){
                  p=argv[arg++];
                  if(dump&&(arg==6)){
                   v=get_ss_obj(p,-2000);  /*** (1 . 0) index ***/
                   v=SCONS(a_quote,SCONS(v,a_nil));
                   x=CDR(x)=SCONS(v,a_nil);
                  }
                  else
                      x=CDR(x)=SCONS(get_ss_obj(p,lev),a_nil);
                  }
                 x=*(stack-1); 
              }
             /*** prin1(x,STDOUT);  ***/
             /*** x=eval_one(x); ** とりあえず  ***/
             /*** x=meval(x,a_nil); ** 03.12.21   1.99***/
             x=vm_eval(x,a_nil); /*** 2010.5.30  V2.0 ***/
             /************************/
             *(stack-1)=x;
             ECHO
               printf("sscmd  vm_eval result %lx\n",(unsigned long)x);
             x=ss_tkstr(x,env,NO);
             if(x!=a_undef){
              p=(char *)get_string(x,&n);
              if(n<199) strncpy(interp->result,p,n);
               else
                *(interp->result)=0;
             }
             else
                *(interp->result)=0;
             /*** prin1(x,STDOUT);     ***/
             pull();
        }
        /**  printf(" ss result %s\n",interp->result);   debug ***/ 
	return TCL_OK;
}



