;;;;  imm-final.ss   from makesr.ss
;;;;   2010.5.31
;;;;   ss2n  Only


(define Undef (make-undef))
(define LAMBDA (NUM 'LAMBDA))
(define MACRO  (NUM 'MACRO))
(define (imm-final lis)
   (let* ((res (cons ()())) (memo res) (x 0)(op 0))
      (while (pair? lis)
        (set! x (pop lis))
        (set! op (car x))
       (if (or  (eq? op LAMBDA)(eq? op MACRO))
          (set! x (list op (imm-final (cadr x))))
          (set! x (imm-trans x))
       )
       (set-cdr! res (cons x ()))
       (set! res (cdr res))
      )
    (cdr memo)
))

(define (imm-trans x)
 (let* ((op (car x)) )
   (if (eq? op  2)   ;;;  IMM
         (begin 
            (set! op (cadr x))
            (cond ((eq? op Undef) (list (NUM 'IMM-undef)))
                  ((eq? op #t) (list (NUM 'IMM-t)))
                  ((eq? op #f) (list (NUM 'IMM-f)))
                  ((eq? op ()) (list (NUM 'IMM-null)))
                  ((eq? op 0) (list (NUM 'IMM-0)))
                  ((eq? op 1) (list (NUM 'IMM-1)))
                  (else x)
            )
         )
       x
    )
)) 

