;;;;;  auto-ext
;;;
;;;     ssss[001-200].jpg
;;;     sss[0-100,2].pdf     ,n is increment
(define (auto-ext url)
   (let* ((x (string-index "[" url))(y 0))
      (if x
        (begin
          (set! y  (string-rindex "]" url))
          (if y
             (auto-ext-main url x y)
              (list  url)
          )
        )
          (list url)
      )
))

(define (auto-ext-main url s e)
   (let* ((x 0)(ind 0)(head 0)(tail 0) (w 0)(ctrl 0)(res ()) (ii 1))
      (set! ind (substring url (+ s 1) e))
      (set! head(substring url 0 s))
      (set! tail(substring url (+ e 1) :end))
      (format #t "~s ~s ~s ~%" head ind tail)
      (set! s (regexp ind #"(\d++)-(\d++)(?(?=,),(\d++))"))
      (if (not s) (set! res (list url)))
      (when s
         (set! s (match-string 1))
         (set! w (string-length s))
         (set! e (match-string 2)) 
         (set! s (string->number s))
         (set! e (string->number e))
         (set! x (match-string 3))
         (if x (set! ii (string->number x)))
         (set! ctrl (tk-string "~a" #\~ w ",'0d~a"))
         (while (<= s e)
            (push (format #f ctrl head s tail) res)
            (inc s ii)
         )
                                                                                                  
      )
   (reverse res)
))

      
      
