;;;;  ̾ξͤδˤ뤳Ȥ
;;;;



;;;;;
(define define-macro (macro (macro-args . macro-body) 
    (list 'define (car macro-args) (list* 'macro (cdr macro-args) macro-body)) )
) 

;;;;  compiler needs
 (define (compiler-eval . x )
   x   ;;;; do nothing
       ;;; However this is a function. So, args are evaluate!!!
        ;;;   used in struct.ss
 )

(define-macro (compiler-not-eval . x )
   `(begin ,@x)    ;;;; do in ss   
)


;;; incomplete
(define-macro (or . or-args)
  (let ((s (gensym)))
    (if (pair? (cdr or-args))
      `(let ((,s ,(car or-args)))
         (if ,s ,s
            (or ,@(cdr or-args))
         )
        )
      (car or-args)
    )
))
;;; incomplete
(define-macro (and . and-args)
  (let ((s (gensym)))
    (if (pair? (cdr and-args))
      `(let ((,s ,(car and-args)))
         (if ,s 
            (and ,@(cdr and-args))
            ,s
         )
       )
     (car and-args)
   )
))

(define-macro (cond cond-x . cond-body)
     (let ()
        (if (null?  cond-body)
          (begin  ;;;  this is last
              (if (or (eq? (car cond-x) 'else) (eq? (car cond-x ) #t))
                  (if (pair? (cdr cond-x))
                             (cons 'begin (cdr cond-x))
                             (make-unspecified)
                  )
                ;;;`(if ,(car cond-x) ,(cadr cond-x))
                `(if ,(car cond-x)
          ,(if (pair? (cdr cond-x)) (cadr cond-x) (make-unspecified)) )
               )
          )
         (begin
         `(if ,(car cond-x) ,(if (pair? (cdr cond-x))
               (cons 'begin (cdr cond-x)) (make-unspecified))
                (cond  ,@cond-body)
            )
          )
       )
))

(define-macro (case case-key . case-body)
   (let ((case-key-res (gensym)) (get-case-body ()) )
     (set! get-case-body
          (map (lambda (case-c) (make-case-c case-key-res  case-c))
               case-body)  )
    `(let ((,case-key-res  ,case-key))
        (cond 
        ,@get-case-body
        )
     )
))
(define (make-case-c key case-c)
  (let ((c-lis 0))
   (if (null? case-c) ()
     (begin
       (set! c-lis (car case-c))
       (set! case-c  (cdr case-c))
       (if (or (eq? c-lis 'else) (eq? c-lis #t))
         `(else  ,@case-c) 
         `((memv ,key (quote ,c-lis)) ,@case-c) 
       )
     )
   )
 ))

(define-macro (call-with-current-continuation proc)
   (list 'call/cc proc)
)

#| test
 (case (* 2 3)
   ((2 3 5 7) 'prime)
   ((1 4 6 8 9) 'composite))
|#
#|
(define-macro (while  cond . body)
   `(do ()
        ((not ,cond))
        ,@body)
)
|#

(define-macro (while  while-cont . while-body)
  (let ((loop-func (gensym)))
   `(letrec ((,loop-func 
               (lambda ()
                   (if ,while-cont
                       (begin ,@while-body
                          (,loop-func))
                    )
               )))
    (,loop-func) )
        
))


(define-macro (do  inits test . do-body)
  (let ((loop-name (gensym)))
    `(letrec ((,loop-name
               (lambda ,(map car inits)
                 (if ,(car test)
                     (begin ,@(if (null? (cdr test))
                                  (list (make-unspecified))
                                  (cdr test)))
                     (begin ,@do-body
                            (,loop-name ,@(map (lambda (init)
                                                 (if (null? (cddr init))
                                                     (car init)
                                                     (caddr init)))
                                               inits)))))))
       (,loop-name ,@(map cadr inits)))))

(define-macro (when when-cont . when-body)
   `(if ,when-cont (begin ,@when-body)))

(define-macro (trace . funcs)
  (let ((fun 0))
    (if (pair? funcs)
        (begin
             (set! fun (car funcs))
             #|
              (if (eq? fun 'apply)
                     (set! apply trace-apply) ;;; see lib.scm
              )
             |#

          `(begin 
                (trace-f ',fun  ,fun)
                (trace ,@(cdr funcs))
           )
        )
        '*trace*
    )
))

;;;; ʲdefscheme	ǤϤޤlistlocalѿˤʤäƤΤǡquasiquoteŸ
;;;;  ȤδؿlistؿǤʤʤäƤޤ
#|
(define-macro (push x list)
  `(begin
        (set! ,list (cons ,x ,list))
        ,list
   )
)
|#

(define-macro (push push-x push-lis-t)
  `(begin
        (set! ,push-lis-t (cons ,push-x ,push-lis-t))
        ,push-lis-t
   )
)

(define-macro (pop  pop-lis-t)
 (let ((var (gensym)))
  `(let ((,var ()))
        (set! ,var (car ,pop-lis-t))
        (set! ,pop-lis-t (cdr  ,pop-lis-t))
        ,var
   )
))

(define-macro (inc var)
     `(set! ,var(1+ ,var)))

(define-macro (dec var)
     `(set! ,var(1- ,var)))

;;;; used OGL,  STk
(define-macro (foreach foreach-var foreach-lis . foreach-body)
   (let ((foreach-lisvar (gensym)))
     `(do ((,foreach-var 0)(,foreach-lisvar ,foreach-lis))
          ((null? ,foreach-lisvar))
          (set! ,foreach-var (car ,foreach-lisvar))
          ,@foreach-body
          (set! ,foreach-lisvar (cdr ,foreach-lisvar))
      )
   )
)
;;;;   eval-interaction
;;;;  -> (:LOAD :REG :ENV)
;;;;
(define-macro (interaction-environment)
   '(LOAD-REG  :ENV)
)


;;;;   for debug
(define-macro (env)
  `(begin
     (write "env: ")
     (write (interaction-environment))
     (newline)
   )
)

;;;;  ***************** end libmacro  ***********************

;;;;;;   chk
#|  OK
(do ((x '( r t u)))
    ((null? x))
   (write (pop x))
   ; (read)
)

OK for x='(1)   Dame for x='(1 2)
OK!   see below

(define (f x)
  (letrec ((g (lambda(x) (if (null? x) x (begin (write (car x)) (g (cdr x)))))))
     (g x)
  )
)

(define (f x)
  (let ((y 9999))
     (write y)
))

(define (f x)
  (let*  ((y 9999)(z y))
     (write z)
))


    dame! for x='(1)   (cdr x) x unbdd!
OK!   changed begin_eval
(define (f x) (if (null? x ) x (begin (write (car x)) (f (cdr x)))))

 (map (lambda(x) (pair? x)) '(3 4 (5)))

|#




