;;;;  yes-no-dialog   ->  confirm.ss
;;;
 (in-package "get-file")
(define (confirm-dialog win  msg)
  (let* ((top (gen-toplevel  ".confirm"))
          (labmsg  (tk-name top '.labmsg))
           (pos (get-win-pos win))
          (geo 0)
          ( ans #t))
   (set! geo (tk-string "200x80+" (+ (car pos) 10) "+" (+ (cdr pos) 5)))
   (wm 'geometry top geo)
   ;;;(wm 'geometry top  "200x70+500+140")
   (wm 'title top "confirm")
   (when  msg
        (label labmsg :text  msg :font '(courier 11))
        (grid labmsg)
   )
   (label  (tk-name top '.lab)  :text " y(es)/n(o) " :font '(courier 11))
   (label  (tk-name top '.img)  :bitmap 'question :fg 'blue)
 ;;;(entry '.load.file )
(grid (tk-name top '.lab) (tk-name top '.img) :sticky 'news )
(bind top  "<Return>" (lambda () (set! ans #t)(destroy top)))
(bind top  "<y>" (lambda () (set! ans #t)(destroy top)))
(bind top  "<n>" (lambda () (set! ans #f)(destroy top)))
(tkwait 'visibility top)
(focus top)
 (grab top)
(tkwait 'window top)
 ans
))

;;;;;
(define (shell-entry local)
  (let* ((top (gen-toplevel  ".sh"))
          (labmsg  (tk-name top '.labmsg))
          (ent  (tk-name top '.ent))
          (win (FILES_WIN-win local))
          (pos (get-win-pos win))
          (geo 0)
          ( ans ""))
   (set! geo (tk-string "400x50+" (+ (car pos) 10) "+" (+ (cdr pos) 5)))
   (wm 'geometry top geo)
   ;;;(wm 'geometry top  "200x70+500+140")
   (wm 'title top "shell window")
   (label labmsg :text  "sh command" :font '(courier 11))
   (grid labmsg)
   (entry ent :width 55)
   (grid ent  :sticky 'ew)
(bind top  "<Return>" (lambda () (set! ans (funcall ent 'get))(destroy top)))
(tkwait 'visibility top)
(focus ent)
 ;;;;(grab top)
(tkwait 'window top)
 ans
))

