(defun hyouka (b w b-1 w-1 )
 (let (eb ew bl bme wme)
   (setq bl (sityo-list b w b-1 w-1 ))
    (setq wl (sityo-list w b  w-1 b-1  ))
    (setq b (take-off b bl))
    (setq w (take-off w wl))
   ;(multiple-value-setq (eb ew) (eikyo b w))
   (multiple-value-setq (eb ew bme wme) (nihei b w))
   ;;; for debug
    (setq *eb* eb *ew* ew)
   ;(+  (- (logcount b)(logcount w))  (- (logcount eb)(logcount ew)))
   (+  (*   (- (logcount bme) (logcount wme))
       (- (group-num ew)(group-num eb))
      )(- (logcount b)(logcount w))  (- (logcount eb)(logcount ew)))
  ;(+ (hyo-sub eb ew bme wme )(* 3 (- (logcount b)(logcount w))))
))
(defun group-num(b)
  (length (block-list b)))

(defun hyo-sub(b w bme wme)
  (let (bl wl x c (sx 0)( sy 0))
    (setq bl (block-list b))
    (setq wl (block-list w))
   (loop
     (if (null bl)(return))
     (setq x (pop bl))
     (setq c (logcount (logand x bme)))
     (if (> c 2) (setq c 2))
     (setq sx (+ sx (* (-  c 0) (logcount x))))
   )
    (loop
     (if (null wl)(return))
     (setq x (pop wl))
     (setq c (logcount (logand x wme)))
     (if (> c 2) (setq c 2))
     (setq sy (+ sy (* (- c  0 ) (logcount x))))
   )
   (- sx sy)
))

;;;nihei's idea:
;;;    amari  yokunai!!!
;;;    3 kaimadeni  suru

(defun nihei(b w)
  (let (bb ww bme wme (i 0))
    (loop
     (if (= i 3)(return))
     (multiple-value-setq (bb ww bme wme)(nihei-sub  b w))
     (and (= b bb)(= w ww)(return))
     (setq b bb w ww)
    (incf i)
   )
   ;(prgo b w)
   ;(setq bbb b www w) ;;;debug!
   (values b w bme wme)
))
(defun nihei-sub(b w)
  (let (x bme wme )
    (multiple-value-setq (b w bme wme)(tokuten b w
        (left b)  (right b)
        (up b)  (down b)
        (left w)  (right w)
        (up w)  (down w)
        ))
   ;(prgo b w)
   (setq bbb b www w) ;;;debug!
   (values b w bme wme)
))
(defun tokuten(b w bl br bu bd wl wr wu wd)
  (let (s s1 x (bme 0) (wme 0))
    (setq s (get-space b w))
    (setq s1 (logand s *1-sen*))
    (setq s (logxor s s1))
  (loop
     (if (= s1 0)(return))
     (setq x (1-te s1))
     (setq s1 (logxor x s1))
     (setq c (count-m x  bl br bu bd wl wr wu wd))
     (cond  ((>= c 1) (setq  b (logior b x)) )
            ((<= c -1)(setq  w (logior w x)) )
            ;((= c 2)(setq  bme (logior bme x)) )
            ;((= c -2)(setq  wme (logior wme x)) )
            (t )
      )
   )
  (loop
     (if (= s 0)(return))
     (setq x (1-te s))
     (setq s (logxor x s))
     (setq c (count-m x  bl br bu bd wl wr wu wd))
     (cond  ((or (= c 1)(= c 2))  (setq  b (logior b x)) )
            ((or (= c -1) (= c -2)) (setq  w (logior w x)) )
            ((> c 2)(setq  bme (logior bme x)) )
            ((< c -2)(setq  wme (logior wme x)) )
            (t )
      )
   )
  ;(setq b (logior b bme) w(logior w wme))
 (values b w bme wme)
))
(defun count-m( x  bl br bu bd wl wr wu wd)
  (let (c)

     (setq  c
       (+ (count-sub x bl)(count-sub x br)(count-sub x bu)(count-sub x bd)))
     (setq  c
       (- c(count-sub x wl)(count-sub x wr)(count-sub x wu)(count-sub x wd)))
))

(defun count-sub (x y)
  (if (zerop (logand x y)) 0 1))


