;; igo.ss  2004.12.17
;;  converted from GCL version
;;;

(define *a* 4)
(define *n+a* (+ *n* *a*))
(define *-n+a* (- *n+a*))
(define *nxn* (* *n* *n*))

(define 1line  (- (expt 2 *n*) 1) )
;;;;   need jouhen no kage   2001.7.30
(define (make-mask n a line)
  (let ( (y 0) )
    (set!  y (ash line a))
   (do ((x y) (i 1))
     ( (= i n) (ash x n))
     (set! x (ash x (+ n a)))
     (set! x (+ x y))
     (inc i)
   )
 
))
   
(define mask (make-mask *n* *a* 1line))

(define (init-mask)
   (set!  1line (- (expt 2 *n*) 1))
   (set!  mask (make-mask *n* *a* 1line))
   (set! *n+a* (+ *n* *a*))
   (set! *-n+a* (- *n+a*))
   (set!  *nxn* (* *n* *n*))

)


(define (left x)
  (ash x -1))
(define ( right x)
  (ash x 1))
(define  (up x)
  (ash x *-n+a*))
(define  ( down x)
  (ash x *n+a*))
;;;;   kosumi
(define (left-u x)
   (ash x (+ -1 *-n+a*)) )
(define (right-u x)
   (ash x (+ 1 *-n+a*)) )
(define (left-d x)
   (ash x (+ -1 *n+a*)) )
(define (right-d x)
   (ash x (+ 1 *n+a*)) )

(define (kosumi-of x)
      (logand mask
       (logior (left-u x) (right-u  x)(left-d x)(right-d x) ))
)

;;;


(define ( dame-of x)
   (logxor x (1-grow x))
)
(define  ( 1-grow x)
   (logand mask 
       ;(logior (left x) (right x)(up x)(down x) x))
       (logior (ash x -1) (ash  x  1)(ash x *-n+a* )(ash  x  *n+a*) x))
)
(define (kawa-of x)
   (let ((y (lognot x)))
      (logand x (1-grow (logand mask y)))
))
(define (center-of x)
  (let ((y (lognot x)))
    (do ((z x))
        ((= x 0) z)
       (set! y (1-grow y))
       (set! z x)
       (set! x (logx-y x  y))
       ;(prgo x)
       ;(wait-return)
     )
))

(define (ketu blist)
  (apply logior blist)
)
  

;;;  data conversion
(define (make-te x)
   ;;;pos= x=0...N^2-1    -> bit-pattern
 (let ((i 0) ( j 0))
  (if (> x *nxn*) 
            0 ;;;;PASS=1000
     (begin
         ;;;(multiple-value-setq (i j) (floor x *n*))
         ;;;(set2! i j (floor-cons  x *n*))
         (set! i (floor x *n*))
         (set! j (modulo x *n*))
         (make-te-sub i j)
     )
  )
))

(define ( make-te-sub i j)
  (let ((k 0) (x 0))
    (set!  x (+ *n*  j *a*  (* i *n+a*)))
    (ash 1 x)
))
(define (get-pos x)
   (let ( (i 0) ( j 0)( y 0))
    (set! y (-(integer-length x)1 *n*))
    ;(multiple-value-setq (i j) (floor y *n+a*))
    ;;;(set2!  i j (floor-cons  y *n+a*))
    (set!  i  (floor y *n+a*))
    (set!  j  (modulo y *n+a*))
    (+ (* *n* i) (- j *a*))
 ))
(define ( get-pos-list b )
   (let  ( (res ()))
     (do  ((x 0))
         ((= b 0)) 
        (set! x (1-te b))
        (set! b (logxor x b))
        (push (get-pos x) res)
     )
   res
))

(define ( get-bit-data  dat)
   (let ( (x dat) (y 0) (b 0)(w 0))
   (do ()
     ( (null?  x))
     (set! y (pop x))
     (if (eq? (car y) *teban*)
           (set! b (logior b (make-te (cadr y))))
           (set! w (logior w (make-te (cadr y))))
    )
 )
   (values b w)
))
;;;   easy print
(define  (prgo b . w)
  (let ( (-n (- *n*)))
    (if (null? w)
           (set! w 0)
           (set! w (car w))
    )
 (newline) 
       (set! b (ash b  -n ))
      (set! w (ash w  -n))
    (do ((i  *n*) (-a (- *a*)))
        ( (= i 0))
      (set! b (ash b -a ))
      (set! w (ash w  -a))
      (prgo-sub (logand 1line b)(logand 1line w))
      ;(prgo-sub  b  w)
       (set! b (ash b -n))
      (set! w (ash w  -n))
      (dec i)
  )
  (newline)
))
(define ( prgo-sub b w)
     (do ((i *n*))
       ( (= i 0))
       (if (= (logand b 1) 1) (display "")
            (if (= (logand w 1) 1)
                        (display "")
                        (display ""))
        )

      (set! b (ash b -1))
      (set! w (ash w -1))
           (dec i)
  )
 (newline)
)



;;;
(define ( 1-te x)
  (highest-bit x)
  ;(logand x (ash 1 (1- (integer-length x) )))
)
;(define ( 1-te x)
  ;(lowest-bit x)
;  (logand x  (logxor x (- x 1)) )
;)

(define (get-pos-list x)
   ;;;  x (bit)  ->  list of pos
  (do ((res ()) (te 0))
      ((zero? x) res)
      (set! te (1-te x))
      (set! x (logxor te x))
      (push (get-pos te) res)
))

(define ( block-list x)
  (let (  (g ()) )
    (do ((y 0))
        ( (= x 0))
       (set! y (gen-block (1-te x) x))
      (push y g)
      (set! x (logxor x y))
    )
  g
))

;(define (gen-block te x)
;     (do ((b 1))
;         ((= b 0))
;        (set!  b (logand x (dame-of te)))
;        (if (=  b 0)
;              ()
;           (set! te (logior te b)) )
;     )
;   te
;)
(define (gen-block te x)
    (set! x (logior x te))
     (do ((b te)(ans 0))
         ((= b ans) ans)
        (set! ans b)
        (set!  b (logand x (1-grow  ans)))
     )
   
)
;;;
(define ( 1-add te x)
  (if (= (logand te x)  0)
       (logior te x)
       nil)
)      

(define ( torare x w)
    (= (s-dame x w) 0)
)

(define  ( s-dame x w)
  (let  ((d 0))
   (set! d (dame-of x))
   (logxor (logand d w) d) 
))


(define (    can-put te black white black-2 white-2)
  (let ((bl 0)( w 0) ( g 0)( gte 0)( wg 0) (z 0))
    (set! bl (1-add te black))
    (if (or (null?  bl) (= (logand te white) te))
       (cons #f #f)
      ;else
      (begin
        (set! gte (gen-block te bl))
        (set! wg (get-near-block te white))
        (set!  w white)
        (do  ()
          ( (null? wg) )
          (set! g (pop wg))
          (set! z (torare g bl))
           (if z
             (set! w (logxor w g)))
         )
       (if (and (= bl black-2)(= w white-2))
               (cons  #f white)
          (begin  ;else
            (if (not (torare gte  white))
                (cons bl w)
               (if (= w white) 
                      (cons  #f  white)
                      (cons bl w)
               )
            )
          )
       )
     )
   )
))

(define ( get-near-block te white)
  (let ((x 0) ( blist ())  )
    (set! x (logand white (1-grow te)))
    (do  ( (g 0))
        ( (= x 0))
      (set! te (1-te x))
      (set!  g (gen-block te white))
      (push g blist)
      (set! x (logxor x (logand g x)))
      ;(set!  white (logxor g white))
   )
  blist
))


(define  (get-bit-history)
    (apply values (get-2-history))
)

(define ( get-empty b w)
   (logand mask (lognot (logior b w)))  )
 
(define (take-off  b bl)
  
    (do ((x 0))
      ( (null?  bl))
      (set! x (pop bl))
      (set! b (logxor b x))
    )
   b
)

;;;   torareru isi no
;;;    list
;;;   b karamite toreru shiro no block no list wo kaesu.
;;;     tori   is in sityo.scm
;;;
(define  ( tori-list b w b-1 w-1)
  (let ((x 0) ( res ()))
   (set! x (block-list w))
   (do ((wb 0))
     ( (null?  x) res)
     (set! wb (pop x))
    (if (tori wb b w b-1 w-1)
           (push wb res))
   )
 ))

(define  (max-block blist)
  (let ( (ans #f) ( k 0) (max 0))
     (do ((x 0))
       ( (null?  blist))
      (set! x (pop blist))
       (set! k (logcount x) )
       (when (> k max)
            (set! ans x)
            (set! max k) )
     )
   ans
))
;;;  from sityo.ss
(define  (tori  wblock  black white  b-1 w-1)
   (let ((d 0) ( x  0) (ans #f))
     (set! d (s-dame wblock black))
     (when (= (logcount d) 1)
        ;(set! x (1-te d))
        (set! x  d)
        (set! ans (car (can-put x black  white  b-1 w-1)))
     )
    ans
))

