;;;   prgo   GUI version
;;;  usage
;;;  (prgui '(b1 b2 ...) '(w1 w2 ...) [win] )
;;;  (prgui b w [win])
;;;
;;;  (prgui+  '(b1 b2 ...) '(w1 w2 ...) color [win])
;;;  (prgui+  b w  color [win])
;;;       koreha,  gamen wo clear sezu hyouji suru.
;;;     background ha color  de hyouji suru.
;;;;default win  is ".pr"  
;;;      for example  ".emp" etc.
;;;
(define *n-prgo* 5)
(define *b-color* "#d9d9d9")
(define *pr-win* ".pr")

(define (prgui blist wlist . win)
   (if (null? win)
          (set! *pr-win* ".pr")
          (set! *pr-win* (car win))
   )
   (if  (and (winfo 'exists  *pr-win*) (= *n-prgo* *n*))
        (init-pr #t)
        (begin
          (if (winfo 'exists *pr-win* ) (destroy *pr-win*))
          (make-pr *n*)
        )
   )
  (set! *b-color* "#d9d9d9")
  (prgui-aux  "@xbm/kuro" blist )
  (prgui-aux  "@xbm/shiro"  wlist )
  (update)

)

(define (prgui+  blist wlist color . win)
    (if (null? win)
          (set! *pr-win* ".pr")
          (set! *pr-win* (car win))
   )

  (set! *b-color*  color)
  (prgui-aux  "@xbm/kuro" blist )
  (prgui-aux  "@xbm/shiro"  wlist )
  (update)
  (set! *b-color* "#d9d9d9")
)


(define (prgui-aux file blist )
  (if  (pair? blist)
     (do ((i 0)(a (char->integer #\a)) )
       ((null? blist))
       (prgui-aux-2 (tk-string file "-" (integer->char (+ i a)) ".xbm")
                    (pop blist))
       (set! i (modulo (+ i 1) 26))
     )
   ;else
     (or (null? blist)
       (prgui-aux-2 (tk-string file  ".xbm")
                     blist)
      )
   )
)
(define (prgui-aux-2  xbm  bits)
   (do ((x 0))
       ((= bits 0))
       (set! x (1-te bits))
       (set! bits (logxor bits x))
       (pr-put (get-pos x) xbm)
   )
)

   
(define (make-pr n)
  (set! *n-prgo* n)
  (toplevel *pr-win*)
  (do ((i 0)(pos 0)(fr 0)(bt 0))
      ((= i n))
      (set! fr (tk-name  *pr-win* '.f i))
      (frame fr)
      (do ((j 0))
          ((= j n))
          (set! bt  (tk-name  *pr-win* '.b pos))
          (button bt :bitmap "@xbm/muji.xbm" :height 24 :width 24 :border 0 )
          (pack bt :in fr :side 'left)
          (inc j)
          (inc pos)
      )
     (pack fr)
     (inc i)
  )
 (init-pr #f)
)
(define (pr-put pos image)
   (eval `(,(tk-name *pr-win* '.b pos) 'configure 
                :bitmap  ,image :background *b-color* ))
)
(define (init-pr clear)
   (when clear
      (do ((i 0)(pos 0)(fr 0)(bt 0)(n *n*))
      ((= i n))
      (do ((j 0))
          ((= j n))
          (set! bt  (tk-name *pr-win* '.b pos))
          (eval `(,bt  'configure 
                    :bitmap "@xbm/muji.xbm" :background "#d9d9d9"  ))
          (inc j)
          (inc pos)
      )
     (inc i)
     )
   )
   
  (do ((u *u-line*))
      ((null? u))
      (pr-put  (pop u) "@xbm/muji5.xbm")
  )
  (do ((u *d-line*))
      ((null? u))
      (pr-put  (pop u) "@xbm/muji6.xbm")
  )
 (do ((u *r-line*))
      ((null? u))
      (pr-put  (pop u) "@xbm/muji8.xbm")
  )
  (do ((u *l-line*))
      ((null? u))
      (pr-put  (pop u) "@xbm/muji7.xbm")
  )
 (let ((u *corner*))
      (pr-put  (pop u) "@xbm/muji1.xbm")
      (pr-put  (pop u) "@xbm/muji2.xbm")
      (pr-put  (pop u) "@xbm/muji3.xbm")
      (pr-put  (pop u) "@xbm/muji4.xbm")
  )
)



     







