;;; netcomm.ss  
;;;   simple communicate with C program with Net
;;;  2004.7.26

(define  *net-pipe*  (netport 51001))
(define *listen-pipe*  (socket-listen *net-pipe*))
(define client-port  (socket-connect *net-pipe*))
(define server-port  (socket-accept  *listen-pipe*))

(define (waitp pid )
   (if (process-exited? pid)
         (close-port client-port) ;;; then we will get eof-object!!!
         (after 500 (lambda ()(waitp pid)))
  )
)

(define pid  (redirect '(run-process "cat"  ) client-port client-port  #f))
(waitp  pid)



