;;; netrun.ss  
;;;   simple communicate with C program with Net
;;;  2004.7.26

(define (net-run  . cmds)
  (let* ((listen #f) (client 0)(stream 0)(net 0)(pid -1) (pr 0))
    (while (not listen)
       (set! net (find-netport))
      (catch (set! listen  (socket-listen net)))
      (when listen
        (set!  client  (socket-connect net))
        (set! stream   (socket-accept  listen))
        (close-port listen)
        (set! pr (map tk-string cmds))
        (set! pr (list (cons 'run-process pr) client client #f))
        (set! pid (apply redirect pr))
        (wait-netrun pid client)
       )
    )
   (cons pid  stream)  
)) 

(define (wait-netrun  pid client )
   (if (process-exited? pid)
         (close-port client) ;;; then we will get eof-object!!!
         (after 5000 (lambda ()(wait-netrun pid client)))
  )
)




