/***   mc.c
   M-compiled obj
   03.12.2
***/
#define MC_PROG

#include "lisp.h"
#include <setjmp.h>
#include <tcl.h>

int input_line=0;  /*** for  line history 04.5.22  ***/
int input_flag=0;  /*** for  line history 04.5.22  ***/

extern Tcl_Interp *myInterp;
extern   ptr assq();

ptr *MPC;   /*** main PC register ***/
          /****  increase image   ***/

extern ptr scm,*pc_stack,M(),M_exp(),M_mc();
extern ptr *get_alloc();

/** extern int narg,level,evalflag;  **/
extern int silent_mode;
/** extern ptr PC[]; **/
extern jmp_buf user_env[];  /****  0 is used for top-level always ***/
extern jmp_buf mc_jmpbuf[];  /****  04.1.9  ***/

/*** #define PUSH(x)  (*pc_stack++=(x)) ***/
#define MPUSH(x)  (*mpu_stack++=(x))
#define MPULL  (*--mpu_stack)
#define FRAME(x) (*(frame_stack+(int)(x)))
#define TRACEP(f)   ((int)FTYPE(f)&TRACE)


#define MCFP(f)   ((int)FTYPE(f)&ALLOC)


/*** ptr *frame_stack;    03.12.2  used in a function, frame variable access
                        in M-compiled function
                        call/cc must (re)store !
              Now in lisp.h   12.24
                   ****/
ptr lbind;  /*** for memo of lambda-bind, used by make-lambda  
                 this is original bind , for TK bind will use **/

extern ptr k_h,k_n,k_B,k_O,k_f,k_t,k_T,k_F,k_N,k_0,k_1,k__1,k_Q,k_u,k_C;
extern ptr k_ESR,k_reg,k_LT,k_J,k_TJ,k_JM,k_D,k_S,k_V,k_L,k_P,k_E,k_I,k_IT,k_IF,k_K,k_LM,k_LB,k_A,k_DA,k_ML,k_MM;

int mcdeb;   /**** for debug of MC ***/

ptr mc_start;  /*** used in error_loop ***/

int narg,level;
int evalflag;   /****  eval can't define   ***/
ptr scm;

extern int gbc_malloc,error_count;

extern ptr M_loop(),MC_callcc();

ptr debug_prev;

ptr s_mc_eval();
static ptr *mcprint();
static ptr make_lambda(), make_macro();
ptr MC();
ptr *MC_adress();
static char *get_mcname();

init_MC(){
  stack=stack_base;
  narg=level=0;
  a_env=a_nil;
  mpu_stack=MPU;
  MPUSH(k_Q);  /*** dummy for :FUNC ***/
  evalflag=0;   /****  eval can't define   ***/
  MPC=k_Q;
}

mctop(){
  Reg ptr p;
  Reg int ntime; 
    jmp_level=1;
    p=calljmp(); /*** jmp 1 ***/
    if(p){
      jmp_level=2;
      lwritestr(STDERR,"jump here mctop  level=2 \n");
    }
    init_MC();
    MC(0); /***  only   set jmp   Now jmp_level=3 ***/
loop:
    if(gbc_malloc){
        gbc();
        gbc_malloc=0;
   }
    if(jmp_level>3){
         /****   :n or :c returned here  ***/
       sprintf(iobuff,"jump  from debug-loop in mctop%d  \n",jmp_level);
       lwritestr(STDERR,iobuff);
       jmp_level=2;
       newline(STDOUT);
        MC(0); /***   only set jmp   ****/
     }
    debug_level=0;
    error_count=0;
    narg=0; /***  needs for debug :n ***/
     if(istty) newline(STDOUT);
     /** printf("top MP %x pc %x stack %x narg %d level %d \n",mpu_stack,pc_stack,stack,narg,level);  ***/
     if(istty)  {
         princ(PROMPT,STDOUT);
     }
            ss_update();
   /** printf("istty %d top_visible %d buffer_white  %d\n",istty,top_visible,buffer_white());**/ 
     if(istty){  
#ifdef USE_TK
            if(top_visible)  update();
#endif
        while(buffer_white()) {   /*** while ***/
                    ss_update();  /*** always check for cygwin   see timer.c ***/
            /*** if(sys_alarm) ***/
             /** { ***/
                    /*** ss_update();  ***/
                   if(sigcode) {
                        sigcode=0;
                        break;
                    }
            /**   }  **/
#ifdef USE_TK
           if(top_visible){
              if(Tk_GetNumMainWindows()>0){  /*** 1 ***/
                 update();
                /*** Tcl_DoOneEvent(0); ***/
              }
             else
                long_jmp(0,p); /****  No window then , jump to tk_lisp Main and
                        initialize TK again     *****/
            }
#endif
         }
      }
     /*** printf("out of buffer shite\n"); ***/
    /** princ(MAKESINT(jmp_level),STDOUT); **/
      input_flag=1;
     /***if(istty){
          p=funcall(ATOMVAL(a_read),0,a_nil);
     }
     else
     ***/
     /*** printf("stack-1 before  %x\n",*(stack-1)); ***/
     if(silent_mode) {
           /** printf("silent visible %d\n",top_visible); ***/
              ss_update();
#ifdef USE_TK
           if(top_visible){
                 /*** update(); ***/
              if(Tk_GetNumMainWindows()>0){  /*** 1 ***/
                  update(); 
                /*** Tcl_DoOneEvent(0); ***/
              }
             else
                long_jmp(0,p); /****  No window then , jump to tk_lisp Main and
                        initialize TK again     *****/
            }
#endif
      goto loop;  /*** because we need ss_date ***/
     }
          p=s_gread(0,a_nil);
     input_flag=0;
     if(istty) line_history(input_line++);

     if((int)p==SEOF){
       s_bye(); /** xit(0); **/
      }
     /*** stack=stack_base; ***/
     /**  p=meval(p,a_nil);  *** normal    ORIG!!!!  ***/
     /*** this direct call causes segmentation error! Why???  ***/
     /*** printf("mc-loop  read %x\n",p);  ***/
     psh(p);
     psh(a_nil);
     *(stack-2)=s_mcompile(2,a_nil);
         init_his();
     *(stack-2)=p=s_mc_eval(2,a_nil);
     if(istty){
       if(multiscm!=a_f){
          if(p==CAR(multiscm))
             prin1(multiscm,STDOUT);
          else
             prin1(p,STDOUT);
          multiscm=a_f;
        }
       else
            prin1(p,STDOUT);
      }
     stack-=2;
     /***  ***/
    /**  prin1(p,STDOUT); ***/
     goto loop;
    }
mcload(ptr lpath){
  ptr p;
    p=calljmp(); 
    if(p){
      jmp_level=2;
       sprintf(iobuff,"jump here mctop  level %d \n",jmp_level);
       lwritestr(STDERR,iobuff);
       return;
    }
    MC(0); /***  only   set jmp   Now jmp_level=3 ***/
loop:
    if(gbc_malloc){
        gbc();
        gbc_malloc=0;
   }
    if(jmp_level>3){
         /****   :n or :c returned here  ***/
       sprintf(iobuff,"jump  from debug-loop in mcload %d  \n",jmp_level);
       lwritestr(STDERR,iobuff);
       jmp_level=2;
       newline(STDOUT);
        MC(0); /***   only set jmp   ****/
     }
    debug_level=0;
    error_count=0;
    narg=0; /***  needs for debug :n ***/
     newline(STDOUT);
     /** printf("top MP %x pc %x stack %x narg %d level %d \n",mpu_stack,pc_stack,stack,narg,level);  ***/
     if(istty)  {
         princ(PROMPT,STDOUT);
         lfflush(STDOUT);
     }
#ifdef USE_TK
     if(istty&&top_visible){
        while(buffer_white()) {
           if(Tk_GetNumMainWindows()>0){  /*** 1 ***/
               Tcl_DoOneEvent(0);
            }
           else
              long_jmp(0,p); /****  No window then , jump to tk_lisp Main and
                        initialize TK again     *****/
         }
      }
#endif
    /** princ(MAKESINT(jmp_level),STDOUT); **/
     p=s_gread(0,a_nil);
     if((int)p==SEOF){
        s_bye(); 
      }
     /*** stack=stack_base; ***/
         init_his();
     p=meval(p,a_nil);  /*** normal  ***/
     if(istty) prin1(p,STDOUT);
     goto loop;
    }


static ptr *print_mc_debug(ptr *memo,ptr *memo_error){
 ptr *prev=0;
  if(memo&&(memo!=k_Q)){
             lwritestr(STDOUT,"** ERROR MC **\n");
             prev=mcprint(memo,-1,memo_error,STDOUT);
             newline(STDOUT);
             lwritestr(STDOUT,"<** ERROR **> ");
             mcprint(prev,-1,memo_error,STDOUT);
            }
          else
            printf("Not in MC\n");
  return prev;
}

error_mctop(int em){
  ptr p,prev,*memo,*memo_error,*memo_prev;
  int n=10;
    scm=a_undef;
    if(em==E_tcl&&ATOMVAL(a_tclerror)==a_f) long_jmp(1,p);
      PRINT(" *** Usege  :q -> top :c ->CONTINUE from error  :n  ->NEXT  :P  print MC  ***\n");
      PRINT("   <number>  :h     print history \n");
      sprintf(iobuff," MC registers  narg %d level %d mc_start %x\n",narg,level,mc_start);
      PRINT(iobuff);
      PRINT(" Environment: ");
      pr_env(a_env);
    /*** print_stack(10); * see  makesub.c ***/
     print_his(10);  
     memo=mc_start;
     memo_error=MPC;
     memo_prev=print_mc_debug(memo,memo_error);

       /***  top of error ****/
       debug_jmp=jmp_level;
       debug_pc=MPC;  /****   MC ***/
       /*** debug_prev=memo_prev; ***/
       debug_stack=stack;
       debug_narg=narg;
        printf("jmp to top of debug MC loop level %d\n",debug_level);
        p=calljmp();
       if(p){ 
          MPC=debug_pc;
          stack=debug_stack;
          narg=debug_narg;
          debug_level=0; 
        }
       debug_level++;
     p=a_undef;
    n=10;
    input_flag=0;
loop:
   newline(STDOUT);
       /** printf("error-top pc-stack %x\n",pc_stack); ***/
    if(p==k_q) {
           sprintf(iobuff,":q  entered prev %x\n",prev);
          PRINT(iobuff);
          long_jmp(1,p);  /*** goto top ***/
      }
     if(p==k_n)  {
         if(debug_level>1) long_jmp(debug_jmp,p);

          /*** sprintf(iobuff,":n  entered prev %x\n",prev);
          PRINT(iobuff);
         ***/

         long_jmp(3,prev);
        }
     if(p==k_c){
         if(debug_level>1) long_jmp(debug_jmp,p);
         MPC=memo_prev;
         long_jmp(3,prev);
       }
     if(p==k_P){   /*** :P   ***/
           print_mc_debug(memo,memo_error);
      }
     if(SINTP(p)){
         n=SINT_NUMB(p);
         }
     if(p==k_h){
          printf(":h  entered n %d\n",n);
         print_his(n);   /*** Func macro history ***/
       }
     prev=scm;
    /** princ(MAKESINT(jmp_level),STDOUT); **/
     princ(error_prompt,STDOUT);
     lfflush(STDOUT);
     p=s_gread(0,a_nil);
     /***
     prin1(p,STDOUT);
     newline(STDOUT);
    ***/
     if(p==SEOF)  {
            s_bye();    /***** to be Modify  ****/
      }
     scm=p;
     if(!SREGP(p)&&(!KEYWORDP(p)))
        scm=meval(p,a_env);
     prin1(scm,STDOUT);
     goto loop;
 }

MC_lambda(){
 int n;
 n=*MPC++;
 lbind=*(MPC+2);  /*** New  **/
 MPC+=n;
} 

MC_make_lambda(){
  int n;
  n=*MPC++;
 scm=make_lambda(MPC-n-2,n,lbind);
 }

MC_make_macro(){
  int n;
  n=*MPC++;
 scm=make_macro(MPC-n-2,n,lbind);
 }


MC_lbind(){
 ptr args;
  /** printf("enter Lambda mpu  %x stack %x env %x\n",mpu_stack,stack,a_env); **/
 args=*MPC++;
 MPC++;  /*** New   ****/
 mc_largs(args);
}

ptr stack_to_list(int narg){   /***  (list  ...)  ***/
  Reg ptr cars=a_nil;
  Reg ptr *p;
  p=stack;
     if(narg==0) return a_nil;
     if(narg < 0) error(E_shortarg,a_nil);  /*** more detail  ***/
        psh(cars);
     loop:
          *(stack-1)=cars=CONS(*--p,cars);
            if(--narg)
             {
              goto loop;
             }
     return *pull();
  }

ptr stack_to_listS(int narg){  /*** (list* ....)  ***/
  Reg ptr cars;
  Reg ptr *p;
  p=stack;
     if(narg==0) return a_nil;
     if(narg < 0) error(E_shortarg,a_nil);  /*** more detail  ***/
        *stack++=cars=*--p;
     loop:
         if(--narg){
          *(stack-1)=cars=CONS(*--p,cars);
          goto loop;
         }
     return *pull();
  }

ptr stack_2_list(ptr *begin,ptr *end){
 ptr res=a_nil;
 while(begin<end){
   res=SCONS(*--end,res);
 }
 return res;
}

mc_largs(ptr args){
 ptr x,ss;
 int i=0;
  if(mcdeb){
   printf("enter mc_largs narg %d  mpu  %x stack %x env %x\n",narg,mpu_stack,stack,a_env); 
   prin1(args,STDOUT);
   newline(STDOUT);
  }
  frame_stack=stack-narg;
  while(CONSP(args)){
    x=CAR(args);
    if(x!=a_f){
        ss=SCONS(x,FRAME(i));
        a_env=SCONS(ss,a_env);
    }
    i++;
    if(--narg<0) checknarg(narg);
    args=CDR(args);
 }
 if(args!=a_nil){ /** rest ***/
        FRAME(i)=ss=stack_2_list(frame_stack+i,stack);
        stack=frame_stack+i+1;
        if(args!=a_f){
           ss=SCONS(args,ss);
           a_env=SCONS(ss,a_env);
        }
 }
 else  if(narg>0)
    checknarg(narg);
  narg=0;
  if(mcdeb)
     printf("exit mc_largs narg %d  mpu  %x stack %x env %x\n",narg,mpu_stack,stack,a_env); 
}

MC_alloc(){
  int n;
  n=*MPC++;
  stack+=n;  /*** stack is inialized by a_unbdd **/
}

MC_dealloc(){
  int n;
  n=*MPC++;
  stack-=n;
}

PUSH_REG(){
  MPUSH(a_env);
  MPUSH(narg);
  MPUSH(stack);
  MPUSH(frame_stack);
}

PULL_REG(){
   frame_stack=MPULL;
   stack=MPULL;
   narg=MPULL;
   a_env=MPULL;
}
     
MC_return(){ 
  ptr f; 
  /***
  if(gbc_malloc){
      gbc();
      gbc_malloc=0;
  }
  ***/
  MPC=MPULL;
  PULL_REG();
   if(mcdeb&&(MPC==k_Q))  printf(" MC_return k_Q  %x\n",MPC);  
   /***
   if(MPC==k_E)  {
       MPC=MPULL;
       printf(" MC_return k_E  %x\n",MPC); 
      longjmp(mc_jmpbuf[--mc_jmp],scm); 
    }
   ***/
  if(*(mpu_stack-1)==k_F){
    /***  return from function call   ***/
    MPULL;
    f=MPULL;
    if(mcdeb)
        printf(" MC_return from function  %x\n",f);  
     if(TRACEP(f)){
             /*** printf("mc_return   trace %x scm %x\n",f,scm); 
              getchar();
             ***/
                trace_out(f,scm); 
              /** if(MPC==k_Q) exit(1); ***/
               /*** mcdeb=0; ***/
        }
  }
}

MC_func(){

  if(SREGP(scm)||!CLOSUREP(scm)) error(E_nullfunc,scm);
  psh_his(CDR(assq(k_T,FENV(scm))));
  MPUSH(scm); /*** function pushed  in MPU   New!!! ***/
  MPUSH(k_F); /*** function pushed  mark  in MPU   New!!! ***/
  PUSH_REG();
  /*** psh(scm); function pushed  in stack! ***/
     /***  ʤ  m.c Ȥ礬Ȥʤ **/
  narg=0;
}

MC_bind(){
ptr var,ss;
var=*MPC++;
  ss=SCONS(var,scm);
 a_env=SCONS(ss,a_env);
}

MC_register(){
ptr var,ss;
var=*MPC++;  /*** Now only :ENV  ***/
  scm=a_env;
}


MC_letbind(){
ptr var,ss,*sfree,*memo;
 var=*MPC++;
 memo=sfree=stack-narg;
 while(narg--){
  ss=SCONS(CAR(var),*sfree++);
  a_env=SCONS(ss,a_env);
  var=CDR(var);
 }
 stack=memo;
}


MC_Senv(){
  ptr x,c;
  x=*MPC++;
  c=assq(x,a_env);
  CDR(c)=scm;
}

MC_Lenv(){
  ptr x,c;
  x=*MPC++;
  c=assq(x,a_env);
  scm=CDR(c);
}

ptr MC_define(){
  Reg ptr var,env,x;
  var=*MPC++;
   if(evalflag) {
       evalflag=0;
       error(E_define,a_define);
    }
  if(ATOMVAL(var)==a_unbdd)
      ATOMVAL(var)=scm; /*** Caution!!!  Modify for TK  ***/
  else
     M_top_value_set(var,scm); /*** see intern.c  ***/
  if(!SREGP(scm)&&CLOSUREP(scm)){
       if((int)FTYPE(scm)&ALLOC){
           env=FENV(scm);
           x=CONS(k_T,var);
           FENV(scm)=SCONS(x,env);
        }
    }
   scm=var;
}

ptr MC_Stop(){
  ptr var;
  var=*MPC++;
  /*** ATOMVAL(var)=scm; * Caution!!!  Modify for TK  ***/
  M_top_value_set(var,scm); /*** see intern.c  ***/
}


ptr mc_jsr(ptr func){  
  int trace;
    Reg   ptr (*addr)();
  ptr env_func;

			
  trace=TRACEP(func);
       if(trace){
          trace_in(func,stack_to_list(narg)); 
          /***  printf("mc_jsr  trace  %x\n",func);  ***/
        }
  /*** scm=jsr(func);  ** New ***/
           addr=CDR(CDR(func));
       env_func=FENV(func);
        scm= (* addr)(narg,env_func);

       /***  if(trace) trace_out(func,scm);  ***/
    /*** PULL_REG();***/
    /***  printf("mc_jsr scm %x\n",scm); ***/ 
 return scm;
}



ptr MC_jsr(){
 ptr f,*mpc;
 int type,trace;
  /** f=MPULL; ***/
 /***  f=*(stack-narg-1);  ***/
  f=*(mpu_stack-6);    /*** New!!! ***/
   /** *MPC++=MC_return;   mazui??? call/cc   to be compiler ???   ****/
 MPC++;  /*** skip narg   ***/
 mpc=MPC;  /*** skip narg, & save MPC for recover   **/
  a_env=CAR(CDR(f));  /*** env in CLOSURE ***/
  type=(int)FTYPE(f);
  trace=TRACEP(f);
  if(!(type&LAMBDA)) error(E_illegal,f);
  if(type&ALLOC){
       if(trace) {
             /** mcdeb=1; **/
             trace_in(f,stack_to_list(narg));
          }
      MPUSH(MPC); 
     MPC=MC_adress(f);  /*** like TAIL-JUMP  for call/cc ***/
     return scm;
  }
 else if(type&SUBR){
    /** MPUSH(MPC-1);  ** if error & :n then MC_return will be executed  ***/
    MPUSH(MPC);  /*** for CALL/CC  this is right?  ***/
    /*** MPC--;        for error in jsr ****/
    /*** MPC=k_Q;  Not MC    ޤߤ***/
     mc_jsr(f);
     MC_return();
     if(mcdeb){
         printf("MC_jsr   scm=");
         prin1(scm,STDOUT);
     }
 }
 else 
     error(99999,f);
    /** return mc_jexp(f);  12.15 ***/
    /** mc_jexp(f); ***/  
  /***  MPC=mpc; ***/
 return scm;
}

MC_jmp(){
  int n;
   n=*MPC++;
  /** printf("M_jmp n %d ",n); **/
   MPC+=n;
}

MC_if_t(){
 int n;
    if(scm!=a_f){
        n=*MPC++; 
        MPC+=n;
    }
    else{
       MPC++;
       }
}

MC_if_f(){
 int n;
    if(scm==a_f){
        n=*MPC++;
        MPC+=n;
    }
    else{
       MPC++;
       }
}

MC_blockin(){ /** mada **/
 psh(a_env);           
 /*** psh(narg); ***/           
 psh(MAKESINT(narg));           
 /*** level++;  No need! already compiled ***/             
}        

MC_blockout(){ /** mada **/
 /*** narg=*pull(); ***/
 narg=SINT_NUMB(*pull());
 a_env=*pull();
 /*** level--;   ***/
}

MC_stacknarg(){
 narg++;
 psh(scm);
 /** prin1(scm,STDOUT); ***/
}

MC_Lframe(){
  scm=FRAME(*MPC++);
  /** printf(" MC_Lframe %d scm",*(MPC-1)); **/
 /*** prin1(scm,STDOUT); **/
}

MC_Sframe(){
  FRAME(*MPC++)=scm;
}

MC_Ltop(){
  scm=*MPC++;
  /*** psh_his(scm);   for debug loop  ***/
  scm=load_top(scm);  /*** see var.c ***/
}

MC_imm(){
 scm=*MPC++;
 /** printf("MC_imm "); ***/
 /** prin1(scm,STDOUT); ***/
}

MC_u(){
  scm=a_undef;
}
MC_t(){
  scm=a_t;
}
MC_f(){
  scm=a_f;
}
MC_0(){
  scm=ZERO;
}
MC_nil(){
  scm=a_nil;
}
MC_1(){
  scm=ONE;
}
MC__1(){
  scm=MINUSONE;
}

MC_tail(){
  Reg ptr f,*sfree,*mpc;
  Reg int n;
  /** f=MPULL; ***/
  /*** f=*(stack-narg-1);  12.6 ***/
  /***
    if(gbc_malloc){
          gbc();
          gbc_malloc=0;
    }
  ***/
  f=*(mpu_stack-6);  /*** New ***/
  sfree=stack-narg;
  stack=frame_stack;
  /*** *(stack-1)=f; ***/
   if(mcdeb){
     printf("MC_tail  mpu_stack %x MPC %x f %x \n",mpu_stack,MPC,f);
     prin1(f,STDOUT);
   }
   n=narg;
  while(n--){
   *stack++=*sfree++;
  }
     if(mcdeb) printf("TAIL-JUMP  para set narg %d stack %x \n",narg,stack); 
  if(MCFP(f)){
     mpu_stack-=6;   /*   drop frame,narg,stack,env  pushed by MC_func   **/
     a_env=CAR(CDR(f));  /*** get closure f 's env ***/
     MPC=MC_adress(f);
     if(mcdeb) printf("TAIL-JUMP  mpu_stack %x MPC %x\n",mpu_stack,MPC); 
  }
 else{
     if(mcdeb){
         printf("TAIL-JSR  mpu_stack %x MPC %x f %x \n",mpu_stack,MPC,f);
     }
   /***   mpu_stack-=4;   drop frame,narg,stack,env  pushed by MC_func   **/
   /** scm=mc_jsr(f);   ??? ***/
    mpc=MPC;  /*** may be change MPC in MC_jsr ***/
    scm=MC_jsr();
     if(mcdeb) printf("TAIL jsr end  mpu_stack %x MPC %x\n",mpu_stack,MPC); 
    MPC=mpc;
   *MPC=MC_return;
   /** MC_return(); ***/
   }
}

ptr *MC_adress(ptr f){
 f=CDR(f);
return (ptr *)(CAR(CDR(f)));
}

static ptr make_mcfunc(ptr *ad,int len, ptr args,int lm){
   Reg ptr f,g,imm,*p,x;
  f=new_cell(lm|SUBR);
  CAR(f)=lm|SUBR|ALLOC|(int)get_argtype(args);
  *stack++=f;
   /*** if(len==0x90) printf("make_mcfunc 0x90\n");    here! ***/
   g=make_alloc(len+2);   /*** New ***/
   psh(g);
   p=(ptr *)CAR(g);
   imm=a_nil;
   while(len--){
     *p++=x=*ad++;
     if(x==MC_imm){
       x=*ad;
       if(!SREGP(x))
           imm=SCONS(x,imm);
     }
   }
   *p++=k_ESR;  /*** New  end mark  ***/
   if(imm!=a_nil)
          imm=SCONS(SCONS(k_I,imm),a_env);
   else
          imm=a_env;
   psh(imm);
   imm=SCONS(SCONS(k_LB,args),imm);  /*** New  ***/
   CDR(f)=g=SCONS(imm,g);
   stack-=3;
  return f;
}

static ptr make_lambda(ptr *ad,int len, ptr args){
   return make_mcfunc(ad,len,args,LAMBDA);
}

static ptr make_macro(ptr *ad,int len, ptr args){
   return make_mcfunc(ad,len,args,MACRO);
}
/***
ptr MC_JSR(ptr *start){ 
 ptr x;

   if(mcdeb)
        printf("MC:start %x stack %x mpu_stack %x a_env %x\n",start,stack,mpu_stack,a_env);
   MPC=start;
loop:
   if(MPC==k_Q) {
       if(mcdeb)
   printf("MC-k_Q: k_Q %x stack %x mpu_stack %x a_env %x\n",MPC,stack,mpu_stack,a_env);
       return scm;
    }
   x=*MPC++;
   ((void (*)())x)();
   if(mcdeb){
   printf("MC-deb: %s MPC %x  stack %x mpu_stack %x a_env %x scm ",get_mcname(x),MPC,stack,mpu_stack,a_env);
   prin1(scm,STDOUT);
   newline(STDOUT);
   }
  if(x==MC_return) return scm;
  goto loop;
}
***/
ptr MC(ptr *start){
 ptr x,p;
       
   if(CAR(a_sysdebug)!=a_f) mcdeb=1;
   else mcdeb=0;

   if(mcdeb)
        printf("MC:start %x stack %x mpu_stack %x a_env %x\n",start,stack,mpu_stack,a_env);
   mc_start=MPC=start;
   frame_stack=stack;  /*** need for (let () ...) with ALLOC ***/
   scm=a_undef;
   if(MPC==0){
    p=calljmp(); /*** jmp 3??? ***/
    if(p){
       /*** printf("JMP to MC()  call/cc  p %x  MPC %x\n",p,MPC); **/ 
      scm=p;  /***  jump value is scm  ***/
     }
     if(MPC==0) return scm;
   }
loop:
   if(MPC==k_Q) { 
       if(mcdeb)
   printf("MC-k_Q: k_Q %x stack %x mpu_stack %x a_env %x\n",MPC,stack,mpu_stack,a_env);
       /** jmp_level--; ** 04.4.30  **/
       return scm;
    }
   sigcheck();  /*** key SIGINT  ****/
   x=*MPC++;
   ((void (*)())x)();
    /** if(scm==M_mc) return scm;  ** return to PC exec exp  ***/
   if(mcdeb){
   printf("MC-deb: %s MPC %x  stack %x mpu_stack %x a_env %x scm\n",get_mcname(x),MPC,stack,mpu_stack,a_env);
   prin1(scm,STDOUT);
   newline(STDOUT);
    /** getchar();  **/
   }
  goto loop;
}


/*****    list of MC-compiled ->alloc data  ****/
static ptr key_adress(ptr x){
 if(SINTP(x)) return SINT_NUMB(x);
 if(CONSP(x)||x==a_nil||x==a_f) return x;  /*** lambda-bind ***/
                           /*** (lambda x ...) may be :LB #f  !!! ***/
 if(SYMBOLP(x)) return x;
 if(x==k_B) x=MC_bind;
 else if(x==k_O) x=MC_blockout  ;
 else if(x==k_I) x=MC_imm  ;
 else if(x==k_n) x=MC_nil  ;
 else if(x==k_f) x=MC_f  ;
 else if(x==k_t) x=MC_t  ;
 else if(x==k_T) x=MC_Stop  ;
 else if(x==k_F) x=MC_func  ;
 else if(x==k_N) x=MC_stacknarg  ;
 else if(x==k_0) x=MC_0  ;
 else if(x==k_1) x=MC_1  ;
 else if(x==k__1) x=MC__1  ;
 else if(x==k_Q) x=MC_return  ;
 else if(x==k_u) x=MC_u  ;
 else if(x==k_C) x=MC_callcc  ;
 else if(x==k_J) x=MC_jsr  ;
 else if(x==k_TJ) x=MC_tail  ;
 else if(x==k_JM) x=MC_jmp  ;
 else if(x==k_D) x=MC_define  ;
 else if(x==k_S) x=MC_Sframe  ;
 else if(x==k_V) x=MC_Senv  ;
 else if(x==k_L) x=MC_Lframe  ;
 else if(x==k_P) x=MC_Ltop  ;
 else if(x==k_E) x=MC_Lenv  ;
 else if(x==k_IT) x=MC_if_t  ;
 else if(x==k_IF) x=MC_if_f  ;
 else if(x==k_K) x=MC_blockin  ;
 else if(x==k_LM) x=MC_lambda  ;
 else if(x==k_LB) x=MC_lbind  ;
 else if(x==k_A) x=MC_alloc  ;
 else if(x==k_DA) x=MC_dealloc  ;
 else if(x==k_ML) x=MC_make_lambda  ;
 else if(x==k_MM) x=MC_make_macro  ;
 else if(x==k_LT) x=MC_letbind;
 else if(x==k_reg) x=MC_register;
 else 
   error(999,x);
return x;
}

static char *get_mcname(ptr  x){
 char *s=NULL;
 if(x==MC_bind) s="bind";
 else if(x==MC_blockout) s="Block-out"  ;
 else if(x==MC_imm) s="IMMIDIATE"  ;
 else if(x==MC_nil) s="(IMM ())"  ;
 else if(x==MC_f) s="(IMM #f)"  ;
 else if(x==MC_t) s="(IMM #t)"  ;
 else if(x==MC_Stop) s="SET-TOP"  ;
 else if(x==MC_func) s="FUNC"  ;
 else if(x==MC_stacknarg) s="STACK-NARG"  ;
 else if(x==MC_0) s="(IMM 0)"  ;
 else if(x==MC_1) s="(IMM 1)"  ;
 else if(x==MC__1) s="(IMM -1)"  ;
 else if(x==MC_return) s="RETURN"  ;
 else if(x==MC_u)  s="(IMM undef)" ;
 else if(x==MC_callcc) s="CALL/CC"  ;
 else if(x==MC_jsr)  s="JSR"  ;
 else if(x==MC_tail) s="TAIL-JMP"  ;
 else if(x==MC_jmp)  s="JMP"  ;
 else if(x==MC_define) s="DEFINE"  ;
 else if(x==MC_Sframe) s="SET-F"   ;
 else if(x==MC_Senv)  s="SET-E"  ;
 else if(x==MC_Lframe) s="LOAD-F"  ;
 else if(x==MC_Ltop)  s="LOAD-TOP"  ;
 else if(x==MC_Lenv) s="LOAD-E"  ;
 else if(x==MC_if_t) s="IF-T"  ;
 else if(x==MC_if_f) s="IF-F"  ;
 else if(x==MC_blockin) s="BLOCK-IN"  ;
 else if(x==MC_lambda) s="LAMBDA-BEGIN"  ;
 else if(x==MC_lbind) s="LAMBDA-BIND"  ;
 else if(x==MC_alloc) s="ALLOC"  ;
 else if(x==MC_dealloc) s="DEALLOC"  ;
 else if(x==MC_make_lambda) s="MAKE-LAMBDA"  ;
 else if(x==MC_make_macro) s="MAKE-MACRO"  ;
 else if(x==MC_register)  s="REGISTER"  ;
 else
   ;
return s;
}


ptr list_to_alloc(ptr com,int len){
 ptr m,*p,x,v;
  m=make_alloc(len+2);
  p=(ptr *)CAR(m);
  while(len--){
    x=CAR(com);
    *p++=key_adress(x);
   if(x==k_I||x==k_reg){
      com=CDR(com);
      *p++=CAR(com);
     len--;
   }
   com=CDR(com);
  }
 *p++=(ptr)MC_return;
 *p=k_ESR;   /***  MC end mark  ***/ 
 return m;
}

ptr comp_to_alloc(ptr *com,int len){
 ptr m,*p,x,v;
  m=make_alloc(len+2);
   /*** if(len==0x8e) printf("comp_to_alloc 0x8e\n");   ***/
  p=(ptr *)CAR(m);
  while(len--){
    x=*com++;
   if(mcdeb){
      printf("alloc  ");
      prin1(x,STDOUT);
      newline(STDOUT);
   }
    *p++=key_adress(x);
   if(x==k_I||x==k_reg){
      x=*p++=*com++;
     len--;
   }
  }
 *p++=(ptr)MC_return;
 *p=k_ESR;   /***  MC end mark  ***/ 
 return m;
}


ptr s_make_mc(int narg,ptr env){
  checknarg(narg-2);
 return list_to_alloc(*(stack-2),SINT_NUMB(*(stack-1)));
}

/************
ptr mc_evalfunc(ptr func){
     ***  already given narg , parameters call by PC see m.c  ***
  ptr m,deb;
   deb=mpu_stack;
   PUSH_REG(); 

  MPUSH(k_Q);    ** for return to here  **

  func=CDR(func);
  a_env=CAR(func);  ** env in CLOSURE *
   ** all pushed data are PULLED by MC_return **
  m=CDR(func);
  scm=MC(CAR(m));
  if(deb!=mpu_stack){
      printf("evalfunc MPU illegal prev %x  now %x\n",deb,mpu_stack);
      prin1(func,STDOUT);
      newline(STDOUT);
  }
   if(mcdeb)  printf("evalfunc out  prev %x  now %x\n",deb,mpu_stack);
  return scm;
}
****/

ptr s_mc_eval(int narg,ptr env){
  ptr m,deb,*mpc,jj;
  checknarg(narg-2);
   
    /** printf("mc_eval enter \n"); ***/
    /** mcdeb=1;  ***/

  deb=mpu_stack;
  mpc=MPC;    /****  This need when jsr call from MC! 
                 because k_Q change MPC and original MPC will be fogotten
                 I spent many time by this bug!!! 
               ***/ 
  /**  this causes can't trace eval  Why?
    MPUSH(ATOMVAL(a_eval));
   MPUSH(k_F);
  **/
   /*** MPUSH(mpc); ***/
   PUSH_REG(); 
    /*** printf("mc_eval PUSH_REG \n");  **/

     /*** MPUSH(k_Q);  * * for return to PC  ***/
         MPUSH(k_Q);
   /*** all pushed data are PULLED by MC_return ****/
  m=*(stack-2); 
  a_env=*(stack-1);
    /*** printf("mc_eval a_env \n");  ***/
     if(mcdeb)
         printf("mc_eval start jmp %d orig-MPC %x  prev %x  now %x\n",mc_jmp,mpc,deb,mpu_stack);
  /** jj=setjmp(mc_jmpbuf[mc_jmp++]); ***/
  /*** if(jj){
    scm=jj;
    mpc=MPC;
  }
  else 
  ***/
       /*****   MC(0) needs if call/cc is used    !!!!!!    ****/
       MC(0);  /*** set jmp only ***/
    /** printf("mc_eval MC(0) \n");  **/
       /*** printf("s_mc_eval  jmp-set %d\n",jmp_level); ***/
       scm=MC(CAR(m));
       jmp_level--;
      /***  printf("s_mc_eval  got scm then jmp-level %d\n",jmp_level); ***/
    if(deb!=mpu_stack){
      printf("mc_eval MPU illegal prev %x  now %x\n",deb,mpu_stack);
  }
     if(mcdeb) 
         printf("MC: mc_eval out  mpc %x prev %x  now %x\n",mpc,deb,mpu_stack);
   MPC=mpc;  /*** recover MPC for MC ***/
  return scm;
} 

ptr s_mcprint(int narg,ptr env){
  ptr s,*p,lpath;
 int n;
  if(narg==1){
     s=*(stack-1);
     lpath=STDOUT;
   }
  else if(narg==2){
    s=*(stack-2);
     lpath=*(stack-1);
  }
  else
     checknarg(narg-2);
 if(SREGP(s)) return a_undef;
 if(CLOSUREP(s)){
      if((int)FTYPE(s)&ALLOC)
          s=CDR(CDR(s));
      else return a_undef;
  }
  check_alloc(s);
  p=get_alloc(s,&n);
   /***  sprintf(iobuff,"mc-start %x\n",p);
  lwritestr(lpath,iobuff);
  ***/
  p=mcprint(p,n,0,lpath);
  newline(lpath);
  /***
  sprintf(iobuff,"mc-end %x\n",p);
  lwritestr(lpath,iobuff);
  ***/
  return a_undef;
}

static char *mc_name_str;

static ptr *mcprint(ptr *p,int n,ptr *err,ptr lpath){
  ptr x,*prev,*memo=p;
  char *q;
  while(n--){
    if(p==err){
        memo=prev;
        lwritestr(lpath," <** ERROR-NEXT **> \n");
    }
    x=*p++;
    if(x==k_ESR) goto end;  /*** end-mark ***/
    if(x==MC_imm){
       prev=p-1;
       q=get_mcname(x);
       /*** printf("%s ",q); ***/
        lwritestr(lpath,q);
        lwritec(lpath,' ');

       x=*p++;
       n--;
        prin1(x,lpath);
        lwritec(lpath,' ');
      }
    else if(OBJP(x)){
        prin1(x,lpath);
        lwritec(lpath,' ');
        }
     else{
       q=get_mcname(x);
       if(q){
          prev=p-1;
          lwritestr(lpath,q);
          lwritec(lpath,' ');
           /**  printf("%s ",q); ***/
          }
       else{
          sprintf(iobuff,"%d ",x);
          lwritestr(lpath,iobuff);
         }
     }
  }
end:
  newline(lpath);
  if(err==0) memo=p-1;
  return memo;
}
