/****  ss cmd 
    tk_ss.c 
   last modified   03.11.3
***/

#include "lisp.h"
#define ECHO   if(tcl_echo)

#include <tcl.h>

extern ptr *pc_stack;

/*
* Declarations for application-specific command procedures
*/
int tk_ssCmd(ClientData clientData,
				Tcl_Interp *interp,
				int argc, char *argv[]);
/*
* The Initialization procedure that is called when
* the package is loaded.
*/
/****
int tk_ssInit(Tcl_Interp *interp) {
	Tcl_CreateCommand(interp, "ss", tk_ssCmd,
			(ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
	return TCL_OK;
}
****/
	/** Tcl_PkgProvide(interp, "ss", "1.1");***/


/*
* This implements the ss Tcl command. With two arguments
* the command returns a integer.
*   ss <obj-adress> <conversion-level>
*/
int
tk_ssCmd(ClientData clientData, Tcl_Interp *interp,
		int argc, char *argv[])
{
	int res, error,arg,lev,dump;
        char *p;
        ptr x,env=a_nil,n,v;
       ECHO
          printf("ssCmd enter\n");
       error = Tcl_GetInt(interp, argv[1], &res);
          if (error != TCL_OK) {
                        return error;
           }
        x=(ptr)res;
       error = Tcl_GetInt(interp, argv[2], &lev);
          if (error != TCL_OK)
                        return error;
	sprintf(interp->result, "%d %d", res,lev); /***  Max 200 bytes P.598 ***/
         if(tcl_echo)
            printf(" ss result %s\n",interp->result); 
         dump=(lev==-4000);
        if(OBJP(x)){
             if(dump) lev=0;  /***more detail    txt 'dump :command ***/
             psh(x);
             if(CLOSUREP(x)){
                  /****   :command (lambda () ......)    ****/
                 env=FENV(x);
                 arg=3;
                 *(stack-1)=x=SCONS(x,a_nil);
                 while(argc-->3){
                  p=argv[arg++];
                  if(dump&&(arg==6)){
                   v=get_ss_obj(p,-2000);  /*** (1 . 0) index ***/
                   v=SCONS(a_quote,SCONS(v,a_nil));
                   x=CDR(x)=SCONS(v,a_nil);
                  }
                  else
                      x=CDR(x)=SCONS(get_ss_obj(p,lev),a_nil);
                  }
                 x=*(stack-1); 
              }
             /*** prin1(x,STDOUT);  ***/
             /*** x=eval_one(x); ** とりあえず  ***/
             /*** x=meval(x,a_nil); ** 03.12.21   1.99***/
             x=vm_eval(x,a_nil); /*** 2010.5.30  V2.0 ***/
             /************************/
             *(stack-1)=x;
             ECHO
               printf("sscmd  vm_eval result %x\n",x);
             x=ss_tkstr(x,env,NO);
             if(x!=a_undef){
              p=get_string(x,&n);
              if(n<199) strncpy(interp->result,p,n);
               else
                *(interp->result)=0;
             }
             else
                *(interp->result)=0;
             /*** prin1(x,STDOUT);     ***/
             pull();
        }
        /**  printf(" ss result %s\n",interp->result);   debug ***/ 
	return TCL_OK;
}



