/***  qquote.c
    quasiquote macro   
    New 10.22 
     see quasi-new.scm   ***/

#include "lisp.h"

extern ptr k_T;

ptr qquote(int narg,ptr env){
 Reg ptr body,x,s=a_nil,res=a_nil,top,tmp;

   checknarg(narg-1);
   body=*(stack-1);
  /**
   printf("quasiquote: body %x\n",body);
   prin1(body,STDOUT);
   **/
   if(SREGP(body)) return body;
   if(ATOM(body)) return SCONS(a_quote,SCONS(body,a_nil));
   
         top=CAR(body);
         if(top==a_unquote) return CADR(body);
        tmp= res=CONS(a_append,a_nil);
        psh(res);                  
           while(CONSP(body)){
          x=CAR(body);
          body=CDR(body);
          if(!SREGP(x)&&CONSP(x)){
             top=CAR(x);
             if(top==a_unquote){
               x=SCONS(a_list,SCONS(_cadr(x),a_nil));
              }
             else if(top==a_unquote_splice){
                x=_cadr(x);
             }
             else {
                 x=SCONS(a_quasi_quote,SCONS(x,a_nil));
                 x=SCONS(a_list,SCONS(x,a_nil));
                 }
           }
           else{
             if(x==a_unquote){
                /***  x=body;   This is Bug!!!  ***/
                x=CAR(body);  /*** 2005.10.10  ***/
                body=a_nil;
               }
             else{
               x=SCONS(a_quote,SCONS(x,a_nil));
               x=SCONS(a_list,SCONS(x,a_nil));
              }
             }
           tmp=CDR(tmp)=SCONS(x,a_nil);
           
          }
          
          if(body!=a_nil){
               x=SCONS(a_quote,SCONS(body,a_nil));
               CDR(tmp)=SCONS(x,a_nil);
        }
   /** printf("quasiquote end  %x\n",*(stack-1)); ***/
    return *pull();
 }

init_quasi(){
Reg ptr scm,tmp,env;
  env=CONS(k_T,a_quasi_quote);
  env=SCONS(env,a_nil);
  scm=make_subr(qquote,(int)subr_argtype(1,0)|SMACRO,env);
  ATOMVAL(a_quasi_quote)=scm;
}

               
               



