/***   apply.c
  03.12.27
  from m.c
  for MC
***/
#define APPLY_PROG
#include "lisp.h"
extern int level,evalflag,narg;
extern ptr s_vm_eval();    /*** V2.0 ***/
extern ptr error();    

int setpara(Reg ptr cdrs){
  Reg int n=0;
  while(CONSP(cdrs)){
   /* printf("\nevalpara %d TYPE cdrs %8x  type nil %8x \n",n,TYPE(cdrs),TYPE(a_nil));*/
    psh(CAR(cdrs));
    cdrs=CDR(cdrs);
    n++;
  }
 return n;
}  

ptr s_apply(Reg int nar,ptr env){
 Reg ptr func=*(stack-nar),*sfree,*memo;
 int n,type;
 if(nar<=1) checknarg(-1);
 nar--;
  memo=stack;
 sfree=stack-nar; 
  if(SREGP(func)) return error(E_nullfunc,func);
   type=(long)FTYPE(func);
  if(!(type&LAMBDA)) return error(E_nullfunc,func);
  stack=stack-(nar+1);  /*** must erace func in stack ***/
 n=0;
 while(nar-- >1){*stack++=*sfree++;n++;};
 n+=setpara(*sfree); 
/** printf("apply narg %d\n",narg);  ***/
 func=funcall(func,n,a_nil);
  stack=memo;
 return func; /*** Caution! not evaluated ****/
}   

ptr s_eval(Reg int nar,ptr env){
  Reg int n=nar;
  ptr scm;
  if(n==1) {
     psh(a_nil);
     n++;
   }
  else 
   checknarg(n-2);
  evalflag=1;
  narg=2;
  /*** scm=s_meval(n,env); ***/
  scm=s_vm_eval(n,env);/*** V2.0 ***/
  evalflag=0;
  if(nar==1) pull();
  return scm;
}

