/****  error.c
    simple version   ***/
/****   error hook  03.10.14  ***/
/****   E_tcl only returns    
        controlled by *tcl-error*  
***/
/**** 
     New m.c	に対応　03.10.18
     03.12.22   MC version  not use PC
****/
/***  STDOUT->STDERR   04.11.14   ***/

#include "lisp.h"
#include <stdlib.h>
#include <stdio.h>

extern  int run_time;
extern  error_top(),print_pc();
extern  ptr *pc_stack,a_env;
extern ptr M_jsr(),M_exp(),M_funcout();
extern ptr VMENV;
extern int long_jmp(int e,ptr val);

/** #define VMENV SYSREG[4]  **/

#define SYMBOLHOME(x)    (CDDDR(x))

extern int evalflag,narg,level;
ptr assq();
extern *MPC;
int error_count=0;
static ptr *memostack=NULL;

ptr s_checkstack(int narg,ptr env){
 if (memostack){
    if(memostack<stack){
        //fprintf(stderr,"stack abnormal %x < %x\n",memostack,stack);
           stack=memostack;
     }
 }
 else
     memostack=stack;
 return a_t;
}

ptr sys_error(int em, ptr p);

#ifdef USE_TK
/***  tk_eval.c  **/
extern int tkreturn,conv_level;
extern char tkcmdbuf[];
#endif

static ptr print_error();

ptr error(int em, ptr p)
{
  ptr msg,x,y,*memo;
  int type;
  evalflag=0;  /*** clear eval error **/
  run_time=1;   /*** see vm_compile.c  **/
  x=MAKESINT(em);
  ATOMVAL(a_errno)=x;
  Errno=x;
  error_count++;
  if(em==E_intrupt){ 
      PRINT("avoid infiny loop");
      newline(STDOUT);
      long_jmp(1,p);  /*** goto top to avoid infinity loop***/
  }
   if(em==E_segm&&error_count>8){
      sprintf(iobuff,"error %x count %d\n",em,error_count);
      lwritestr(STDERR,iobuff);
      print_error(em,p,STDERR);
      error_count=0;
      long_jmp(1,p);  /*** goto top to avoid infinity loop***/
   }
   /***     exit(999); ***/
  /*** ATOMVAL(a_error_env)=a_env;***/
  ATOMVAL(a_error_env)=VMENV;  /*** V2.0 ***/
  VMENV=a_nil;
/***
  PRINT("error_env");
  prin1(VMENV,STDOUT);
 newline(STDOUT);
***/
  x=ATOMVAL(a_errorhook);

#ifdef DEBUG
  PRINT("error_hook is ");
  prin1(x,STDOUT);
 newline(STDOUT);
#endif
  if(!SREGP(x)&&CLOSUREP(x)){
      /*****   errorhook!!!  *****/
#ifdef DEBUG
     PRINT("Here errorhook did't work???\n");  
#endif
        type=(long)FTYPE(x);
     ATOMVAL(a_errorhook)=CONS(x,a_nil);/*** save but not closure
                 for true error in hook-func  ***/
     if(!(type&LAMBDA)) {
       error(E_nullfunc,x);
     }
     memo=stack;
     psh(MAKESINT(em));
     psh(p);
    funcall(x,2,a_nil);   /*****/
     /**  stack-=2;    ***/
     stack=memo;
#ifdef DEBUG
         printf("errorhook return\n"); /**  DEBUG ***/
#endif
     Errno=0;
     y=ATOMVAL(a_syserrorhook);
     if(CLOSUREP(y)){
        *(stack-2)=MAKESINT(E_hookreturn);
        funcall(y,2,a_nil);   /**  to be by call/cc&& not return  ***/
     }
     y=ATOMVAL(a_errorhook);
     if(CLOSUREP(y))
         error(E_hookreturn,x);  /*** to be catch in top-level ***/ 
    /***  ATOMVAL(a_errorhook)=x;  **reload hook 2010.8.31 ***/
#ifdef DEBUG
         printf("errorhook return2\n"); /**  DEBUG ***/
#endif
      if(istty){
           fprintf(stderr,"istty long_jmp %d\n",jmp_level);
         long_jmp(jmp_level-1,(ptr)1);
        }
       else
         exit(0);  /** Never reach if load catch hook return ***/
        /***  see myload.ss  **/
   /*** return sys_error(em,p);  * continue system error **/
     /*** hook-chk   OK!  03.12.25 ***/
     /***  printf("errorhook did't work???\n"); ***/
      /** long_jmp(1,p);  goto top ,  No! V2.0 ***/
   }
   return sys_error(em,p);
}

ptr sys_error(int em, ptr p)
{
    evalflag=0;  /*** clear eval error **/
  ATOMVAL(a_error_env)=VMENV;  /*** V2.0 ***/
   print_error(em,p,STDERR);
#ifdef USE_TK
    s_print_last_tcl(0,a_nil);
#endif
    if(istty){
       long_jmp(1,(ptr)(long)em); /***   V2.0  jmp  2010.6.8 **/
      /***  Do nothing V2.0 ,  see vm.c   error_top
      if(debug_level)
          long_jmp(debug_jmp,(ptr)em); 
      error_mctop(em);    ***   MC!  
      ***/
      return a_undef;
    }
    else
     exit(1);
    /***     long_jmp(0,em);  never reach  V2.0, No jmp  **/
}


static ptr print_error(int em,ptr p,ptr lpath){
 ptr msg;
  msg=assq(MAKESINT(em),CAR(a_errmsg));
  evalflag=0;   /**** error in eval ***/
  if(msg!=a_f) princ(CDR(msg),lpath);
    else{
      lwritestr(lpath," User error ");
       prin1(MAKESINT(em),lpath);
        newline(lpath);  
    }
  if(em== E_unprint){
      sprintf(iobuff," error unprintable object =%lx\n",(unsigned long)p);
      lwritestr(lpath,iobuff);
   }
  else if(em== E_segm){
     if(p!=a_nil)
        prin1(p,lpath);
     newline(lpath);
  }
  else
    {
      lwritestr(lpath,":  ");
       if(!SREGP(p)&&SYMBOLP(p)){
             prin1(SYMBOLHOME(p),lpath);
             /** newline(STDOUT); ***/
       }
      prin1(p,lpath);
      /***
      if(OBJP(p))
           printf("   obj adress %x attr %x car %x cdr %x \n",p,ATTR(p),CAR(p),CDR(p));
       ***/
     newline(lpath);
    }
  return a_undef;
}

ptr s_print_error(int narg,ptr env){
  ptr num,obj,lpath;
   if(narg==2){
      num=*(stack-2);
      obj=*(stack-1);
      lpath=STDERR;
  }
  else if(narg==3){
      num=*(stack-3);
      obj=*(stack-2);
      lpath=*(stack-1);
  }
 else    
     checknarg(narg-3);
   return print_error(SINT_NUMB(num),obj,lpath);
}

fatal_error(int em, ptr p)
{
  ptr msg;
  msg=assq(MAKESINT(em),CAR(a_errmsg));
  /*** if(msg!=a_f) prin1(CDR(msg),STDOUT); ***/
    /*** prin1(p); ***/
  printf(" Last object %lx. *** Fatal!!!  exit *****\n",(unsigned long)p);
  s_bye();
  exit(em);
}

ptr s_error(int narg,ptr env){
checknarg(narg-2);
return error(SINT_NUMB(*(stack-2)),*(stack-1));
}

ptr s_sys_error(int narg,ptr env){
checknarg(narg-2);
sys_error(SINT_NUMB(*(stack-2)),*(stack-1));
}


