#include "lisp.h"
#include <setjmp.h>
#include <signal.h>
#include <stdio.h>

/*** #define calljmp()   setjmp(user_env[jmp_level++])   in lisp.h ***/
extern char *alloc_space();
extern void timer_handler();
extern int ctrlcexit;

jmp_buf user_env[10];  /****  0 is used for top-level always ***/
/*** jmp_buf mc_jmpbuf[500];  **  0 is used for top-level always ***/

int debug_level=0;
extern int verbose_mode;

int sigcheck();

long_jmp(int x,ptr val){
 longjmp(user_env[x],(int)(long)val);
}

/***  signal handler ***/
void sig_int(int sig){
 sprintf(iobuff,"signal %d received!\n",sig);
 lwritestr(STDERR,iobuff);
/*** for debug ***/
/*** init_sig();  ***/
/** signal(SIGINT,sig_int); **/
/*** long_jmp(0,sig);  ***/
 sigcode=sig;
  if(sig==SIGSEGV){ /*** segmentation violation ***/
     lwritestr(STDERR,"*** segmentation violation ***\n");
  if(ctrlcexit) s_bye(0,a_nil);
     error(E_segm,a_nil);
    /***  ϲΤޤ  ***/
  }
  if(ctrlcexit&&(sig==SIGINT)) s_bye(0,a_nil);
  long_jmp(1,(ptr)(long)sig);  /*** V2.0 2010.6.8  **/
  /*** if(sig==SIGINT){ *** interrupt **
     sigcheck();
  }
  ***/
}

init_sig(){
int n;
sigcode=0;
n=(long)signal(SIGSEGV,sig_int);
if(n==(long)SIG_ERR)  goto err;
n=(long)signal(SIGTSTP,sig_int);
if(n==(long)SIG_ERR)  goto err;
n=(long)signal(SIGINT,sig_int);
if(n==(long)SIG_ERR)  goto err;
n=(long)signal(SIGPROF,timer_handler);
n=(long)signal(SIGALRM,timer_handler);   
   if(verbose_mode){
       sprintf(iobuff,"timer handler set %x\n",n);
       lwritestr(STDMSG,iobuff);
   }
if(n==(long)SIG_ERR)  goto err;
   if(verbose_mode)
       lwritestr(STDMSG,"signal handler set\n");
timer_init();
    return;
 err:
    lwritestr(STDMSG,"*** signal error **** \n");
    long_jmp(0,a_nil);
}
/** n=signal(SIGALRM,sig_int); **/

sigcheck(){
  if(sigcode){
     sigcode=0;
     error(E_intrupt,a_nil);
    }
}

/****   get jump buffer from space ****/
/***
static jmp_buf *get_jmpbuf(){
  ptr q;
 *stack++=q=CONS(a_nil,a_nil);
  MARK(q)=JMP;
  CDR(q)=ZERO;
  sprintf(iobuff,"size of jmp %x\n",sizeof(jmp_buf));
  lwritestr(STDERR,iobuff);
  ** fprintf(stderr,"size of jmp %x\n",sizeof(jmp_buf)); ***
  return (jmp_buf *)alloc_space(q,sizeof(jmp_buf));
  **** CAUTION!!!!   stack++ , so *--stack  for getting scm jmp_buf object
    by caller   ******
} 
***/
ptr s_sigclear(int narg,ptr env){
     sigcode=0;
    return a_t;
}

ptr s_sigcheck(int narg,ptr env){
     return MAKESINT(sigcode);
}

