/***  macroexpand.c
     macro expand  
      New 10.19
     use   M-machine  tric
****/

#include "lisp.h"
#include <stdlib.h>

#define PUSH(x)  (*pc_stack++=(x))
#define MPUSH(x)  (*mpu_stack++=(x))

extern ptr *pc_stack,*mpu_stack,*stack,M_exp();
int narg,macro_eval;
extern ptr k_T;   /** PC[],M_loop(); **/
//extern ptr macro_ex2();

static ptr smacroex();
ptr macroex();
/***
ptr s_macroexpand(int narg,ptr env){
   ptr x ;
    x=*(stack-1);
   ** printf(" s_eval %x env %x\n",x,env); *
   checknarg(narg-1);
   if(SREGP(x)) return x;
   if(CONSP(x)) return macroex(x);
   return   x;
}
***/

ptr macroex(Reg ptr form)
 {
         Reg ptr cars,cdrs,func,whole,fenv,self,*memo;
         Reg int kind,n;

      Reg   ptr (*addr)();
     cars=CAR(form);
     cdrs=CDR(form);
    /*** 03.12.21  ***/
    if(SREGP(cars))
         error( E_nullfunc,cars);
    if(CONSP(cars))  /*** ((lambda ...) ...) ***/
              return form;
    /*** we don't permit ((macro ...) ...)  ***/
    if(SYMBOLP(cars))
        func=ATOMVAL(cars);
    else
       func=cars;
     if(SREGP(func)||(!CLOSUREP(func))) error( E_nullfunc,cars);
    /****  Now not used
     if(ATTR(func)==SR2MACRO) {
        **** return form;   ** IN vm_comp.c **
        return macro_ex2(cars,cdrs);
        }
     ****/
          kind=(long)FTYPE(func);
          if(!(kind&MACRO)) return form;
          if(kind&SUBR)    return smacroex(func,kind,cdrs);
         /***  not compiled  ***/
   PRINT("Macro but Not compiled->exit ");
   s_bye();
   exit(1119);
}

static ptr smacroex(ptr func,int type,ptr cdrs){
   Reg   ptr (*addr)();
   ptr env_func;
   int n,nar=narg;
       /*** pull();   drop arg ***/
       addr=(ptr (*)())CDR(CDR(func));
       env_func=FENV(func);
       /***  03.12.27 for debug ***/
        psh_his(assq(k_T,env_func));
      n=setpara(cdrs);  /** param to stack ***/
      if(type&ALLOC){
          narg=n;
           /** func=mc_evalfunc(func); ***/
           func=funcall(func,narg,env_func);
          narg=nar;
      }
      else
            func=(* addr)(n,env_func);
       stack-=n;
       return func;
}


