;;;  DL win  from ssweb separated
;;;
(in-package "http")
(require "http-base")
(load "autoext")
(define *proxy-select* 0)
(define *pmenu-max* 0)
;;;  DL
(define *dl-win* #f) ;;; DL-listbox
(define *dl-ysc* #f) ;;; DL-listbox-ysc
(define *dl-header* #f) ;;; DL-header
(define *dl-status* #f) ;;; DL-status
(define *dld-index* ())
(define *DL-win-accept* #t)  ;;; accept changes of  dl-win
(define *DL-win-que* ())  ;;; win-out que when not accepted

(define (gen-dl)
   (let* ((dl (gen-toplevel '.dlWIN))
          (dlm  (tk-name dl  '.dlm))
          (dlm-ysc  (tk-name dl '.dlmysc))
          (dlm-go  (tk-name dl '.go))
          (dlm-load  (tk-name dl '.load))
          (dlm-stop  (tk-name dl '.stop))
          (dlm-clear  (tk-name dl '.clear))
          (dlm-status  (tk-name dl '.status))
          (dlm-header  (tk-name dl '.header))
          (dlm-hysc  (tk-name dl '.dlmhysc))
          (dlm-proxy  (tk-name dl '.proxy))
          (dlm-proxy-label  (tk-name dl '.proxylab))
          (dlm-proxy-reset  (tk-name dl '.proxyreset))
          (dlm-max  (tk-name dl '.max))
          (pmenu 0)
          ;;;(dlm-act  (tk-name dl '.stop))
         )
   ;; (funcall dl   'configure :menu dlm-proxy)
   ;;(menu dlm-proxy)
   (label dlm-proxy-label :text "Not use" :width 22 :relief 'ridge)
   (label dlm-max :relief 'ridge )
   (dlmax dlm-max)
   (set! pmenu (make-proxy-menu dlm-proxy dlm-proxy-label))
   (button dlm-proxy-reset :text "Reset-proxy"  :command
      (lambda()  (reset-proxy-menu pmenu dlm-proxy-label)))

   (listbox  dlm :width 60 :height 10 :exportselection #t
        :selectMode 'extended
        :yscrollcommand (lambda l (apply (function dlm-ysc)  'set l)))
   (scrollbar dlm-ysc :orient 'vertical
            :command (lambda l (apply (function dlm) 'yview l)))
    (funcall dlm 'insert 'end  #\space)  ;;;;   dummy one line
   (button dlm-load :text "LOAD" :command (lambda()(load-url dlm)))
   (button dlm-go :text "GO/DL" :command '(go-url))
   (button dlm-stop :text "STOP" :command '(stop-url))
   (button dlm-clear :text "CLEAR" :command '(clear-url))
    (label dlm-status :text "OK           " :width 40)
   (text dlm-header  :height 12 :exportselection #t :yscrollcommand
       (lambda l (apply (function dlm-hysc)  'set l)))
   (scrollbar dlm-hysc :orient 'vertical
            :command (lambda l (apply (function dlm-header) 'yview l)))

   (grid  dlm-load :sticky 'news :row 0 :column 0)
   (grid  dlm-go :sticky 'news :row 0 :column 2)
   (grid  dlm-stop :sticky 'news :row 0 :column 3)
   (grid  dlm-clear :sticky 'news :row 0 :column 4)
   (grid  dlm-max :sticky 'news :row 0 :column 5)
   (grid  dlm-proxy :sticky 'news :row 0 :column 6)
   (grid  dlm-proxy-label :sticky 'news :row 0 :column 7)
   (grid  dlm-proxy-reset :sticky 'news :row 0 :column 8)

   (grid  dlm  :sticky 'news :columnspan 9 :row 1)
   (grid  dlm-ysc :sticky 'news :row 1 :column 9)
   (grid 'columnconfigure dl 1 :weight 1)
   (grid 'rowconfigure dl 1 :weight 1)
    (grid  dlm-status :columnspan 4  :row 2 :column 1)
    (grid  dlm-header  :sticky 'news :columnspan 9 :row 3)
   (grid  dlm-hysc :sticky 'news :row 3 :column 9)
   (bind dlm-max "<Button-3>"  (lambda() (dec *DL-MAX*) (dlmax dlm-max)))  
   (bind dlm-max "<Button-1>"  (lambda() (inc *DL-MAX*) (dlmax dlm-max)))  
   (set! *dl-win* dlm)
   (set! *dl-header* dlm-header)
   (set! *dl-status* dlm-status)
   (set! *dl-ysc* dlm-ysc)
   (tkwait 'visibility dl )
))

(define (dlmax lab)
   (if (< *DL-MAX* 1) (set! *DL-MAX* 1))
   (if (> *DL-MAX* 5) (set! *DL-MAX* 5))
   (funcall lab 'configure :text (tk-string "MaxDL " *DL-MAX* "  "))
)


(define  (make-proxy-menu menub lab)
   (let* ((pmenu 0) (p  0)(pro 0)(n 0)(lis *Proxy-list*))
      (set! pmenu (tk-name  menub '.non))
      (menubutton menub :text "Proxy" :menu pmenu :activeBackground 'blue 
       :relief 'raised)
      ;;;(funcall menub 'add 'cascade  :label "Proxy"  :menu pmenu )
      (menu pmenu :tearoff 'no)
      (set! *proxy-select* 0)
      (funcall pmenu 'add 'command :label "Not use" :command
           (lambda() (set! *Proxy* #f)
             (funcall pmenu  'entryconfigure *proxy-select*  :foreground 'black)
             (set! *proxy-select* 0)
             (funcall lab 'configure :text "Not use")
             (funcall pmenu  'entryconfigure 0 :foreground 'blue))  )
    (while (and (pair? lis) (< n 7))
       (set! pro (pop lis))
       (inc n)
       (set! p (tk-string  (car pro)#\: (cadr pro)))
       (add-pmenu  pmenu lab  pro p n)
       (if (= n 1)
          (default-pmenu  pmenu lab  pro p n)
       )
   )
  (set! *pmenu-max* n)
  pmenu
))

(define (default-pmenu pmenu lab proxy plab n)
   (set! *Proxy* proxy)
   (set! *proxy-select* n)
   (funcall lab 'configure :text plab)
   (funcall pmenu  'entryconfigure 0 :foreground 'black)
   (funcall pmenu  'entryconfigure n :foreground 'blue)   
)

(define (add-pmenu pmenu lab proxy plab n)
    (funcall pmenu 'add 'command :label plab :command
            (lambda() (set! *Proxy* proxy)
              (funcall pmenu  'entryconfigure *proxy-select*  :foreground 'black)
              (funcall lab 'configure :text plab)
              (set! *proxy-select* n)
              (funcall pmenu  'entryconfigure n :foreground 'blue))  )
)

(define (config-pmenu pmenu lab proxy plab n)
   (funcall pmenu  'entryconfigure n :foreground 'black
             :label plab :command
                 (lambda() (set! *Proxy* proxy)
              (funcall pmenu  'entryconfigure *proxy-select*  :foreground 'black)
              (funcall lab 'configure :text plab)
              (set! *proxy-select* n)
              (funcall pmenu  'entryconfigure n :foreground 'blue))  )
)

(define  (reset-proxy-menu pmenu lab)
   (let* ((p  0)(pro 0)(n 0)(lis 0))
      (read-proxy)    ;;;;  read again
      (set! lis *Proxy-list*)
      (set! *proxy-select* 0)
    (while (and (pair? lis) (< n 7))
       (set! pro (pop lis))
       (inc n)
       (set! p (tk-string  (car pro)#\: (cadr pro)))
       (if (>  n *pmenu-max*) 
         (add-pmenu pmenu lab pro  p  n)
         (config-pmenu pmenu lab pro  p  n)
       )
        (if (= n 1)
          (default-pmenu  pmenu lab  pro p n)
       )
   )
  (set! *pmenu-max* n)
))


(define (go-url)
  (let* ((lis *dl-win*) (dld 0)(ind (listbox-index lis))(dlis  0)(url 0))
     ;;;(format #t "url ~s~%" ind)
     (if (= (length ind) 1)
        (begin
          (set! dlis (rassq (car ind) *dld-index*)) 
          (if dlis  (set! dld (car dlis)))
          (when  (and dlis (DLD-url dld))
               (if  (DLD-ishtml dld)
                     (DL-force  dld)  ;;;???
                     (act-url ind)
               )
           )
        )
      (if (pair? ind) (act-url ind))
    )
))

(define (act-url ind-list)
  (let* ( (state 0)(dl 0)(ind 0)(dld  0)(id 0))
;;;    (format #t "url ~s~%" ind-list)
     (while  (pair? ind-list)
         (set! ind (pop ind-list))
         (set! dld (rassq ind *dld-index*))
         ;;(format #t "act id ~s~%" id)
         (when (and dld (DLD-url (car dld)))
             (set! dld (car dld))
             (set! state (DLD-dlstate dld)) 
;;;         (format #t "act state  ~s dld ~s~%" state dld)
             (cond ( (eq? state 'URL) 
                          (start-que dld)  ) 
                   ((or (eq? state 'bookmark) (eq? state 'STP)
                           (equal? state 'END)( eq? state 'ERR))
                        (restart-que dld)  )
                   (else)
             )
        )
    )
))

(define (stop-url)
  (let* ((lis *dl-win*) (state 0)(dl 0)(ind 0)(ind-list (listbox-index lis))(url 0)(dld 0))
     ;;;(format #t "url ~s~%" ind)
     (while  (pair? ind-list)
         (set! ind (pop ind-list))
         (set! dld (rassq ind *dld-index*)) 
        ;; (format #t "stop id ~s~%" id)
         (when dld
             (set! dld (car dld))
             (set! state (DLD-dlstate dld)) 
           ;;; (format #t "stop state  ~s~%" state)
           (cond ((eq? state 'QUE)
                    (remove-que dld)
                  ;; (format #t "stop state  ~s~%" state)
                     (DL-win-out dld 0 0 'STP)
                 )
               ((eq? state 'URL)
                   (DL-win-out dld 0 0 'STP) )
               ((eq? state 'ACT)
                     (set! *DL-enable* #f)
                     (push dld *DL-cancel*)
                     (set! *DL-enable* #t)
                  )
               (else)
           )
        )
    )
))

(define (clear-url)
  (let* ((lis *dl-win*) (state 0)(dl 0)(clear ())(memo ())
            (ind 0)(ind-list (listbox-index lis))(url 0)(dld 0))
     ;;;(format #t "url ~s~%" ind)
     (set! *DL-accept* #f)
     (set! *DL-win-accept* #f)
     (set! ind-list (sort ind-list >))  ;;; from big
     (while  (pair? ind-list)
         (set! ind (pop ind-list))
         ;;(set! dl (funcall lis 'get ind))
         ;;;(set! id (regexp dl #"^\d+"))
         (set! dld (rassq ind *dld-index*))
         (when  dld
             (set! dld (car dld))
             (set! state (DLD-dlstate dld))
  ;;;   (format #t "clear-url ~s ~s~%" ind state)
           (cond ((or (eq? state 'END) (eq? state 'STP))
                   ;;;(format #t "clear state  ~s~%" state)
                   (push ind clear)   ;;; clear is from little
                   (funcall lis 'delete ind ) ;;; from big
                 )
               (else)
           )
        )
     )
     (if (pair? clear) (clear-dld-index clear lis))
     (newline)
     (set! *DL-accept* #t)
     (set! *DL-win-accept* #t)
     (while (pair? *DL-win-que*)
        (apply DL-win-out (pop *DL-win-que*))
     )
))


(define (clear-dld-index clear listbox)
   (let* ((memo (reverse *dld-index*)) (s  ()) (k 0) (c 0)(d 0) (ind 0))
      ;;;(sort clear <)
      (set! c (pop clear))
      (while (pair? memo)
         (set! d (pop memo))
         (set! ind (cdr d))
         (if (= ind c)
              (begin
                  ;;;(funcall listbox  'delete (- ind k))
                  (inc k)
                  (if (pair? clear) (set! c (pop clear)))
              )
              (if (> k 0)
                   (push (cons (car d)  (- ind k) ) s)
                   (push d s)
              )
         )
      )
     (set! *dld-index* s)
))

;;;  download window
;;;
(define (selection-recover ind listb)
   (while (pair? ind)
      (funcall listb 'selection 'set (pop ind))
   )
)

(define (ysc-recover gets ysc)
  (funcall ysc 'set (car gets) (cadr gets))
)

(define (DL-win-up  dld state)
  (when  (not (assq dld  *dld-index*))
    (let* ((ind 0) (lis *dl-win*)
            (memo (listbox-index lis))  
            (obj (DLD-object dld))
            (url (DLD-url dld))
          )
      ;;;       (ysc-memo (funcall *dl-ysc* 'get))
     (set-DLD dld :dlstate state)
     (if (not obj) (set! obj "html"))
     (if (not url) (set! url "-----"))
;;;     (format #t "dlwin-up: ~s ~s ~s ~s ~%" url obj state ind)
       (set! ind (funcall lis 'index 'end))
       (dec ind)                                ;;; if does'not, we can not see the last line
       ;;;(format #t "DL-win ind ~s~%" ind)
       (push (cons dld ind)  *dld-index*)
      (if *DL-win-accept*
          (begin
            (funcall lis 'insert ind (tk-string state #\space  obj #\space url ))
            ;;;(funcall lis 'insert 'end  #\space)
            ;;;(if (string-index "htm" obj) (funcall lis 'see 'end))
          )
          (push (list dld 0 0 state) *DL-win-que*)
     )
   ;;;(ysc-recover ysc-memo *dl-ysc*)
   (selection-recover memo lis)
    ind
  )
))

(define (DL-win-out dld len total state )
    (if *DL-win-accept*
        (DL-win-out-exec  dld len total state )
        (when (eq? state 'END)
          (push (list dld len total state) *DL-win-que*)
          (set-DLD dld :dlstate state)
        )
    )
)

(define (DL-win-out-exec  dld len total state )
   (let* ((ind  (assq dld *dld-index*)) (obj (DLD-object dld))
           (url (DLD-url dld))   (lis *dl-win*)(memo (listbox-index lis))
         )
     (if (not ind)  
         (DL-win-up dld state)
       (begin   
          (set! ind (cdr ind))
          ;;; (format #t "DL-win-out ind ~s state ~s~%" ind state)
          (if (not obj) (set! obj ""))
          (funcall lis 'delete ind)
          (funcall lis 'insert ind (tk-string  state #\space obj
               #\space len #\/ total #\space url)) ;;; never newline
      ;;;    (when (= ind  (cdar *dld-index*))
      ;;;           (funcall lis 'yview 'scroll 1 'units) )
          (selection-recover memo lis)
          (set-DLD dld :dlstate state)
      )
    )
))

;;; bookmark
(define (read-bookmark-file  file )
   (let* ((in (open-input-file file)) (x 0)(dld 0))
     (if in
       (begin
         (set! x (read-line  in))
        (while (not (eof-object? x))
          (set! dld (request-DLD x "GET" #f #f))
         (DL-win-up dld 'bookmark )
         (set! x (read-line  in))
         )
          (close-port in)
          file
       )
       #f
     )
))
(define (read-bookmark . file-list)
 (let* ((f #f))
  (while (and (not f) (pair? file-list))
    (set! f (pop file-list))
    (if (file-exists? f)
        (set! f (read-bookmark-file f ))
        (set! f #f)
    )
  )
   (if (not f) (format #t "Not exists bookmark ~%" ))
))

;;;  load url file
(define (read-url-file  file )
   (let* ((in (open-input-file file)) (x 0)(dld 0)(url 0) (obj 0)(url-list 0))
     (set! x (read-line  in))
     (while (not (eof-object? x))
       (set! url (regexp x #"http:[^\s]+"))
       (when url
          (set! url-list  (auto-ext url))
          (while (pair? url-list)
             (set! url (pop url-list))          
             (set! dld (request-DLD url "GET" #f #f))
             (DL-win-up  dld  'URL )
          )
       )
       (set! x (read-line  in))
     )
    (close-port in)
))

(define (load-url lis)
   (let* ((file (get-file-name "*.href")) (ind 0)(owari 0))
      (when  file
           (set! ind (funcall lis 'index 'end))
           (dec ind)
           (read-url-file file )
           (set! owari (funcall lis 'index 'end))
           (dec owari)
           (funcall lis 'selection 'set ind owari)
      )
))

;;;(gen-dl)   for start



