;;;  rxvt definitions
;;;;  04.6.1
;;;
;;; rxvt

;;;   key boad sequence
;;;
(in-package "tty")
(define *input-controls* ())
(make-control cur-up  #\escape  #\[ #\A)
(make-control cur-down  #\escape  #\[ #\B)
(make-control kcur-right  #\escape  #\[ #\C)
(make-control kcur-left  #\escape  #\[ #\D)
(make-control his-up         (CTRL #\U))
(make-control his-down        (CTRL #\Y) )
(make-control cur-begin-end       (CTRL #\P) )
(make-control read-chk        (CTRL #\O) )
(make-control read-end        (CTRL #\Q) )
(make-control scr-insert-new        (CTRL #\D) )
(make-control delete-line          (CTRL #\E) )
(make-control delete       #\delete )
(make-control backspace       #\backspace )

;;;;  diplay control  definitions
;;;;
(define Up    (string-append  ESC  "[A"))
(define Down  (string-append  ESC  "[B"))
(define Right (string-append  ESC  "[C"))
(define Left  (string-append  ESC  "[D"))

;;; 0 black 1 red  2 green  3 yellow  4 blue   5 mazenda  6 sian 7 gray ?
;;; 8  no-effect(?)  9 white
(define gray 7)    ;;; for newline at the end of line
(define white 9)   ;;;  original bg color
(define blue 4)
(define sian 6)
(define mazenda 5)

;;;;   we use N= 2,3,4,5,1 to indicate the level of ()  
(define (set-fg n)
  (display  ESC )
  (display   "[3")
  (display n)
  (display 'm)
)

(define (set-bg n)
  (display  ESC )
  (display   "[4")
  (display n)
  (display 'm)
)

#|   ;;; Not used
(define Bold    (string-append (string #\escape) "[1m"))
(define Smso    (string-append (string #\escape) "[7m"))
(define Setab    (string-append (string #\escape) "[47m"))   ;;; back white
(define Setaf    (string-append (string #\escape) "[30m"))  ;;; char black
|#
