(define x (net-run "sftp" "s3"))
(define pid (car x))
(define p (cdr x))

(define (send x)
    (format p "~a~%" x)
)

(define (recv)
   (if (char-ready? p)
       (p-read p)
       (format #t "Not ready")
   )
)

(define (p-read p)
  (let* ((x 0)(buf ()))
    (while (char-ready? p)
       (set! x (read-char p))
       (push x buf)
    )
   (set! buf(reverse buf))
   (format #t "buf:~s~%" buf)
   (list->string buf)
))

(define (k)
   (kill pid)
)
