;;;  2010.7.10  psyntax
;;;

(define (make-psyntax lite pat template)
  (let* ((vars 0)(env 0) (ans 0))
   (set! *literal* lite)
   (set! pat (s->pat pat)) 
   (set! template (template-trans template))
   (set! vars *vars*)
   (set! env *macro-env*)
   (lambda (x)
       (set! *vars* vars)
       (set! *macro-env* env)
       (set! ans (s-match pat x))
       (if ans
          (cons #t (template-exec template))
          #f
        )
     )
))

;;;;  yet, fender is not supported
 (define syntax-case
   (let* ((rules #f)(form 0))
      (lambda (exp  lite  .  clauses)
        (let* ((ans #f))
          ;;;(set! form (eval exp ()))
          (set! form  exp )
          (if (and rules (pair? rules))
            (begin
             (while (and (not ans)(pair? rules))
                (set! ans ((car rules) form))
                (if (pair? ans)
                  (set! form (cdr ans)) 
                )
               (set! rules (cdr rules))
             )
             (if ans form (error E_illegal exp))
            )
           (begin
             (while (pair? clauses)
               (set! form (car clauses))
               (push  (make-psyntax lite (car form)(cadr form)) rules)
               (set! clauses (cdr clauses))
             )
             (set! rules (reverse! rules))
             (apply syntax-case exp lite clauses)
           )
         )
      )
    )
))

(define (f x)
     (syntax-case x () '((or) #f) '((or x) x) 
         '((or x y ...) (let*  ((temp x)) (if temp temp (or y ...))))) 
)
            
                  
   
