;;;2010.8.3
;;;
(in-package "macro")

(define (identifier? x) (or (symbol? x)(syntax-symbol? x)))

(define (syntax-object->datum x)
   (cond ((pair? x)
            (cons (syntax-object->datum  (car x)) 
                  (syntax-object->datum  (cdr x)))   ) 
         ( (syntax-obj? x)
            (if (syntax-lambda? x)
                   x
                 (object->datum (<-syntax x))  )) 
         (else x)
    )
)

(define (object->datum x)
     x   ;;;;  toriaezu 
)

(define (syntax-equal? x y)
   (and (equal? (syntax-car x) (syntax-car y))
    (equal? (syntax-cdr x) (syntax-cdr y)))
)
;;; P.196
;;;    ... appears in template
;;;    something wrong ,  may be wrong the book
;;;;   No!  Mysystem has a wrong parti?
(define-syntax with-syntax
  (lambda (x)
     (syntax-case x (syntax)
       ((_ ((p e0) ...) e1 e2 ...)
          (syntax (syntax-case (list e0 ...) ()
                   ((p ...) (begin e1 e2 ...))))))))
;;;          ((p ...) (begin (eval (syntax e1)) (eval (syntax e2))  ...))))))))
                    ;;((p ...)  (syntax (begin e1 e2 ...)))))))))

;;;;                    ((p ...) (begin e1 e2 ...))))))))

(export '(identifier? syntax-object->datum object->datum syntax-equal? with-syntax))

#| check   Not work!  8.26
 (with-syntax ((rest  (fact 10)))
      (syntax rest))
;;;;   3628800

;;; dame
(define-syntax OR
   (lambda(exp)
      (syntax-case exp ()
        ((_) (syntax #f))
        ((_ x) (syntax x))
        ((_ x y z ...) 
           (with-syntax ((rest (syntax (OR y z ...))))
                 (syntax (let ((t x)) (if t t rest))))   ))))
;;;;  この展開をするとき、with-syntax をevalして新たなpattern matchingがおこる。
;;;;  従って、そのあとsyntax を実行しようとしても正しい代入が行われない。
;;;;  つまり、transformerを実行するとき現在のpattern matchingの情報を
;;;;  保存して復帰しないといけない。
;;;;
;;;;  これでもまだ不十分。上の例では、with-syntax の中のxは、その上のlevel
;;;; のsyntax-case のpat-varになっている。しかし、with-syntaxのlevelでは
;;;; restのみがpat-varであり、xはfreev と誤解されてしまう。
;;;; literalに上のlevelのシンボルを追加で解決するか？
;;;;   いや、そうではない。この展開では、with-syntax がeval されるのだが
;;;; そのとき、(let (t x)のxがsyntax-varであることは、with-syntaxからはわからない。
;;;; 
;;;;   syntaxの解釈が問題だったのだ。templateは、syntaxがあってもなくても
;;;;  展開されなければならない。そしてevalされるのだが、syntaxはそれを阻止
;;;; するのである。
;;;;    (syntax x)
;;;; は、xを変換して(+ 1)と展開しそのまま返す。
;;;;     x
;;;;;   であれば、(+ 1)をevalするので、それは1である！
;;;;

|#

