;;;  2010.8.1  psyntax-aux
;;;   make *syntax-binds*
;;;;

(in-package "macro")
;;;(define *syntax-binds*  ())
(define *bind-env* ())

(define (make-syntax-bind key f)
  (set! *bind-env* ())
  (bind-env f)
  (push-syntax-binds key *bind-env*)
  ;;;(push (cons key *bind-env*) *syntax-binds*)
  *bind-env* 
)

(define (bind-env f)
   (if (pair? f)
         (if (and (eq? (car f) 'syntax) (pair? (cdr f)))
               (bind-env-syntax (cadr f))
               (begin
                  (bind-env (car f))
                  (bind-env (cdr f))
               )
         )
   )
 )

(define (bind-env-syntax  f)
   (if (symbol? f)
        (bind-env-symbol f)
       (if (pair? f)
         (if (not (eq? (car f) 'quote))
           (begin
            (bind-env-syntax (car f)) 
            (bind-env-syntax (cdr f))
           )
         )
       )
   )
)

(define (bind-env-symbol f)
    (or (assq f *vars*) 
        (assq f *macro-env*)
        (assq f *literal*)
        (assq f *bind-env*)
        (eq? f *macro-key*)
        (eq? f '...)
            (if (symbol-bind? f)
               (push (cons f (symbol-value f)) *bind-env*)
             )
    )
)
