;;;; compile-file given *argv*
;;;;

;;;(require "compiler")
;;;(load "compile-file")
(require "compile-file")

(if (pair? *argv*)
  (while (pair? *argv*)
     (compile-file (car *argv*))
     (set! *argv* (cdr *argv*))
  )
  (let* ((s (glob-file "*.ss" "*.ss2")) (f 0)(fr 0))
    (while (pair? s)
       (set! f (pop s))
       (set! fr (make-name-sr2 f ))
       (if (file-exists? fr)
           (if (> (file-time fr)(file-time f)) (set! f #f))
       )
       (if f  (compile-file f))
    )
   )
)
   
(bye)

