;;;;  lib for TCL/TK
;;;;  use  tk  package    04.5.16

 ;;;;;  CAUTION!!!!  in "tk"   exists tk:if  ,tk:while !!!!

;;;;(define IF ss:if)

(in-package "tk")
(export 'tk-init-cmd)
;;;;******************************************************
(compiler-eval (unintern "if") (unintern "while"))
;;;;******************************************************

(define (tkcmds->string  . args)
   (let ((s "")(x 0))
      (while (pair? args)
         (set! x (car args))
         (set! x (tk-str x)) ;;;;keyword->option x)))
         (set! s (string-append s x " "))
         (set! args(cdr args))
      )
  s
))


(define (tk-init-cmd x tcl-name)
   (tk-make-cmd x tcl-name :text "" :width 0 :height 0 :command "")
)

(define-macro (lindex lindex-lis lindex-n)
  `(list-ref ,lindex-lis ,lindex-n))


;;;  should do  after TK initialization!
;;;  this called in sslisp_tk.c  

;;;(define ss:*root* ())   ;;;   ****  TK main window .   ****
;;;;(define ss:oglwin ())
(intern "*root*" "ss")  ;;;;  No good  'ss:OGLwin
(define *root* ())  
(intern "oglwin" "ss")  ;;;;  No good  'ss:OGLwin
(intern "OGLwin" "ss")  ;;;;  No good  'ss:OGLwin
(define (oglwin . x)(format #t "~%*** TkOGL not installed!!! ****~%~%") (bye))
;;;(define Tk-after ())
    'ss:tk_dialog 
    'ss:tk_setPalette 
     'ss:tk_bisque   
(define *shadowing-tk*  ())

;;;(define Tk-glob  ())

(define (tk-init)
 (let* ((s 0) (x 0)(v 0)(undef (make-undef)))
    (set! s  (tcl "info commands"))
    ;;;(format #t "tk-init start:~s~%" s)
    ;;;(tcl-echo 1)
   (while (pair? s)
     (set! x (car s))
      ;;;(format #t "~s~%" x)
     (when (not (string? x))
        (format #t "illegal commands in TCL ~s~%" x)
      )
     (when (string? x)
        (set! x   (intern x "ss"))  ;;;(string->symbol x)
        (set! v (symbol-bind? x))
        (if v 
          (begin
            (if (eq? (eval x ())  undef)
                (set! v x)
                 ;;;  tk- is no good , tk-string rewrited!
                ;;;(set! v (string->symbol (string-append "Tk-" (symbol->string x))))
                (begin
                   (set! v (shadowing-intern (car s) "tk"))
                   (push v *shadowing-tk*)
                )
            )
            (tk-init-cmd v x)
            ;(if (eq? v x)
            ;    (format #t "~s " x)
            ;    (format #t "~&~s  defined  with Tk-  ~%" v)
            ;)
          )
          (begin
            ;(format #t "~s " x)
            (tk-init-cmd x x)
          )
       )
    )
    
    ;;;(format #t "tk init  commands ~s ~s ~%" v x)
    (set! s (cdr s))
   )
    ;;;; (tk-init-cmd 'echo 'echo)   echo is not TCL command!  Don't use
    ;;;;(tk-init-cmd 'man  'man)  ;;;; manual, use (man 'button --> lib.scm
    (tk-init-cmd 'tk_dialog  'tk_dialog)  
    (tk-init-cmd 'tk_setPalette  'tk_setPalette)  
    (tk-init-cmd 'tk_bisque 'tk_bisque)  
    ;;;(wm 'withdraw ".")
    (set! *root* (eval |.| ()))   ;;;  *root* ,|.|  are same 
    ;;; (focus :force "") dame
   (if  (symbol-bind? 'OGLwin)
       (set! oglwin OGLwin)
   )
   ;;;(make-after-cmd)
    ;;;(make-glob-cmd)
))

(define *after-cmds* ())
#|
(define (make-after-cmd)
    (set! Tk-after after)
  (set! after
    (let ((op 0)(id 0)(cmd 0)(adress 0))
      (lambda  args 
         (set! op (car args))
       ;;;;;  in "tk"   exists tk:if  !!!!
         (if (and (or (number? op) (eq? op 'idle)) (pair? (cdr args)))
            (begin
              (set! cmd (cadr args))  ;;;  allow only one command
              (if (not (member cmd  *after-cmds*))
                 (set! *after-cmds*  (cons  cmd *after-cmds*))
              )
              (set! adress (obj-address cmd))
              (set! adress (string-append "ss "  adress " 0"))
              (Tk-after op adress)
            )
          (apply Tk-after args)
         )
      )
    )
  )
)
|#
(define (gen-toplevel  name)
  (set! name (tk-name name))
  (if (winfo 'exists  name)
        (do ((i 1 (+ i 1))(ok #f)(gen name))
            ( ok (set! name gen))
            (set! gen (tk-name name i))
            (set! ok (not (winfo 'exists  gen)))
         )
  )
  (toplevel name)
   name
)

(export 'gen-toplevel)
(use-package "tk" "ss")
#|                      ----->  lib.scm  using exec glob
(define (make-glob-cmd)
    (set! Tk-glob glob)
    (set! glob
          (lambda pat 
             (let ((files ()))
               (catch (set! files (apply Tk-glob pat)))
               (if  (string? files) (list files)
                  files)
             )
           )
     )
)
|# 
#|
;;;  (after 100) support
;;;
(in-package "ss")
(define after ())
(in-package "tk")
(define (make-after-cmd) 
  (let* ((tkafter (find-symbol "after" "tk")))
  (set! after (lambda  (msec . cmd)
             (if (pair? cmd )
                ( ss-after msec (car cmd))
                 (funcall tkafter msec)
              )
             )
 )
))
|# 
